## clonezilla-live-src-2.5.0-5-i686-pae.debian.tar

=== CMakeLists.txt ===
# nghttp2 - HTTP/2 C Library
#
# Copyright (c) 2012, 2013, 2014, 2015 Tatsuhiro Tsujikawa
# Copyright (c) 2016 Peter Wu <peter@lekensteyn.nl>
#
# Permission is hereby granted, free of charge, to any person obtaining
# a copy of this software and associated documentation files (the
# "Software"), to deal in the Software without restriction, including
# without limitation the rights to use, copy, modify, merge, publish,
# distribute, sublicense, and/or sell copies of the Software, and to
# permit persons to whom the Software is furnished to do so, subject to
# the following conditions:
#
# The above copyright notice and this permission notice shall be
# included in all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
# EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
# MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
# NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
# LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
# OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
# WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

cmake_minimum_required(VERSION 3.0)
# XXX using 1.8.90 instead of 1.9.0-DEV
project(nghttp2 VERSION 1.16.0)

# See versioning rule:
#  http://www.gnu.org/software/libtool/manual/html_node/Updating-version-info.html
set(LT_CURRENT  26)
set(LT_REVISION 0)
set(LT_AGE      12)

set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")
include(Version)

math(EXPR LT_SOVERSION "${LT_CURRENT} - ${LT_AGE}")
set(LT_VERSION "${LT_SOVERSION}.${LT_AGE}.${LT_REVISION}")
set(PACKAGE_VERSION     "${PROJECT_VERSION}")
HexVersion(PACKAGE_VERSION_NUM ${PROJECT_VERSION_MAJOR} ${PROJECT_VERSION_MINOR} ${PROJECT_VERSION_PATCH})

if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
  set(CMAKE_BUILD_TYPE RelWithDebInfo CACHE STRING "Choose the build type" FORCE)

  # Include "None" as option to disable any additional (optimization) flags,
  # relying on just CMAKE_C_FLAGS and CMAKE_CXX_FLAGS (which are empty by
  # default). These strings are presented in cmake-gui.
  set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS
    "None" "Debug" "Release" "MinSizeRel" "RelWithDebInfo")
endif()

include(GNUInstallDirs)

# For Python bindings and documentation
# (Must be called before PythonLibs for matching versions.)
find_package(PythonInterp)

# Auto-detection of features that can be toggled
find_package(OpenSSL 1.0.1)
find_package(Libev 4.11)
find_package(ZLIB 1.2.3)
if(OPENSSL_FOUND AND LIBEV_FOUND AND ZLIB_FOUND)
  set(ENABLE_APP_DEFAULT ON)
else()
  set(ENABLE_APP_DEFAULT OFF)
endif()
find_package(Jansson  2.5)
set(ENABLE_HPACK_TOOLS_DEFAULT ${JANSSON_FOUND})
# 2.0.8 is required because we use evconnlistener_set_error_cb()
find_package(Libevent 2.0.8 COMPONENTS libevent openssl)
set(ENABLE_EXAMPLES_DEFAULT ${LIBEVENT_OPENSSL_FOUND})
find_package(Cython)
find_package(PythonLibs)
if(CYTHON_FOUND AND PYTHONLIBS_FOUND)
  set(ENABLE_PYTHON_BINDINGS_DEFAULT ON)
else()
  set(ENABLE_PYTHON_BINDINGS_DEFAULT OFF)
endif()

find_package(LibXml2 2.7.7)
set(WITH_LIBXML2_DEFAULT    ${LIBXML2_FOUND})
find_package(Jemalloc)
set(WITH_JEMALLOC_DEFAULT   ${JEMALLOC_FOUND})
find_package(Spdylay 1.3.2)
set(WITH_SPDYLAY_DEFAULT    ${SPDYLAY_FOUND})

include(CMakeOptions.txt)

if(ENABLE_LIB_ONLY AND (ENABLE_APP OR ENABLE_HPACK_TOOLS OR ENABLE_EXAMPLES OR
  ENABLE_PYTHON_BINDINGS))
  # Remember when disabled options are disabled for later diagnostics.
  set(ENABLE_LIB_ONLY_DISABLED_OTHERS 1)
else()
  set(ENABLE_LIB_ONLY_DISABLED_OTHERS 0)
endif()
if(ENABLE_LIB_ONLY)
  set(ENABLE_APP            OFF)
  set(ENABLE_HPACK_TOOLS    OFF)
  set(ENABLE_EXAMPLES       OFF)
  set(ENABLE_PYTHON_BINDINGS OFF)
endif()

# Do not disable assertions based on CMAKE_BUILD_TYPE.
foreach(_build_type "Release" "MinSizeRel" "RelWithDebInfo")
  foreach(_lang C CXX)
    string(TOUPPER "CMAKE_${_lang}_FLAGS_${_build_type}" _var)
    string(REGEX REPLACE "(^| )[/-]D *NDEBUG($| )" "" ${_var} "${${_var}}")
  endforeach()
endforeach()

#
# If we're running GCC or clang define _U_ to be "__attribute__((unused))"
# so we can use _U_ to flag unused function parameters and not get warnings
# about them. Otherwise, define _U_ to be an empty string so that _U_ used
# to flag an unused function parameters will compile with other compilers.
#
# XXX - similar hints for other compilers?
#
if(CMAKE_C_COMPILER_ID MATCHES "GNU" OR CMAKE_C_COMPILER_ID MATCHES "Clang")
  set(HINT_UNUSED_PARAM   "__attribute__((unused))")
  set(HINT_NORETURN       "__attribute__((noreturn))")
else()
  set(HINT_UNUSED_PARAM)
  set(HINT_NORETURN)
endif()

include(ExtractValidFlags)
foreach(_cxx1x_flag -std=c++11 -std=c++0x)
  extract_valid_cxx_flags(_cxx1x_flag_supported ${_cxx1x_flag})
  if(_cxx1x_flag_supported)
    set(CXX1XCXXFLAGS ${_cxx1x_flag})
    break()
  endif()
endforeach()

include(CMakePushCheckState)
include(CheckCXXSourceCompiles)
cmake_push_check_state()
set(CMAKE_REQUIRED_DEFINITIONS "${CXX1XCXXFLAGS}")
# Check that std::future is available.
check_cxx_source_compiles("
#include <vector>
#include <future>
int main() { std::vector<std::future<int>> v; }" HAVE_STD_FUTURE)
# Check that std::map::emplace is available for g++-4.7.
check_cxx_source_compiles("
#include <map>
int main() { std::map<int, int>().emplace(1, 2); }" HAVE_STD_MAP_EMPLACE)
cmake_pop_check_state()


# Checks for libraries.
# Additional libraries required for programs under src directory.
set(APP_LIBRARIES)

if(ENABLE_PYTHON_BINDINGS)
  if(NOT (CYTHON_FOUND AND PYTHONLIBS_FOUND))
    message(FATAL_ERROR "python bindings were requested "
      "(ENABLE_PYTHON_BINDINGS=1) but dependencies are not met.")
  endif()
  if(NOT PYTHON_VERSION_STRING STREQUAL PYTHONLIBS_VERSION_STRING)
    message(FATAL_ERROR
      "Python executable and library must have the same version!"
      " Found Python ${PYTHON_VERSION_STRING} and"
      " PythonLibs ${PYTHONLIBS_VERSION_STRING}"
    )
  endif()
endif()

set(CMAKE_THREAD_PREFER_PTHREAD 1)
find_package(Threads)
if(CMAKE_USE_PTHREADS_INIT)
  list(APPEND APP_LIBRARIES ${CMAKE_THREAD_LIBS_INIT})
endif()
# XXX android and C++, is this still needed in cmake?
# case "$host" in
#   *android*)
#     android_build=yes
#     # android does not need -pthread, but needs followng 3 libs for C++
#     APPLDFLAGS="$APPLDFLAGS -lstdc++ -latomic -lsupc++"

# dl: openssl requires libdl when it is statically linked.
# XXX shouldn't ${CMAKE_DL_LIBS} be appended to OPENSSL_LIBRARIES instead of
# APP_LIBRARIES if it is really specific to OpenSSL?

find_package(CUnit 2.1)
enable_testing()
set(HAVE_CUNIT      ${CUNIT_FOUND})
if(HAVE_CUNIT)
  add_custom_target(check COMMAND ${CMAKE_CTEST_COMMAND})
endif()

# openssl (for src)
set(HAVE_OPENSSL    ${OPENSSL_FOUND})
if(OPENSSL_FOUND)
  set(OPENSSL_INCLUDE_DIRS  ${OPENSSL_INCLUDE_DIR})
else()
  set(OPENSSL_INCLUDE_DIRS  "")
  set(OPENSSL_LIBRARIES     "")
endif()
# libev (for src)
set(HAVE_LIBEV      ${LIBEV_FOUND})
set(HAVE_ZLIB       ${ZLIB_FOUND})
set(HAVE_LIBEVENT_OPENSSL ${LIBEVENT_FOUND})
if(LIBEVENT_FOUND)
  # Must both link the core and openssl libraries.
  set(LIBEVENT_OPENSSL_LIBRARIES ${LIBEVENT_LIBRARIES})
endif()
# jansson (for src/nghttp, src/deflatehd and src/inflatehd)
set(HAVE_JANSSON    ${JANSSON_FOUND})
# libxml2 (for src/nghttp)
set(HAVE_LIBXML2    ${LIBXML2_FOUND})
if(LIBXML2_FOUND)
  set(LIBXML2_INCLUDE_DIRS  ${LIBXML2_INCLUDE_DIR})
else()
  set(LIBXML2_INCLUDE_DIRS  "")
  set(LIBXML2_LIBRARIES     "")
endif()
# jemalloc
set(HAVE_JEMALLOC   ${JEMALLOC_FOUND})
# spdylay (for src/nghttpx and src/h2load)
set(HAVE_SPDYLAY    ${SPDYLAY_FOUND})

if(ENABLE_ASIO_LIB)
  find_package(Boost 1.54.0 REQUIRED system thread)
endif()

# The nghttp, nghttpd and nghttpx under src depend on zlib, OpenSSL and libev
if(ENABLE_APP AND NOT (ZLIB_FOUND AND OPENSSL_FOUND AND LIBEV_FOUND))
  message(FATAL_ERROR "Applications were requested (ENABLE_APP=1) but dependencies are not met.")
endif()

# HPACK tools requires jansson
if(ENABLE_HPACK_TOOLS AND NOT HAVE_JANSSON)
  message(FATAL_ERROR "HPACK tools were requested (ENABLE_HPACK_TOOLS=1) but dependencies are not met.")
endif()

# C++ library libnghttp2_asio
if(ENABLE_EXAMPLES AND NOT (OPENSSL_FOUND AND LIBEVENT_OPENSSL_FOUND))
  message(FATAL_ERROR "examples were requested (ENABLE_EXAMPLES=1) but dependencies are not met.")
endif()

# third-party http-parser only be built when needed
if(ENABLE_EXAMPLES OR ENABLE_APP OR ENABLE_HPACK_TOOLS OR ENABLE_ASIO_LIB)
  set(ENABLE_THIRD_PARTY 1)
  # mruby (for src/nghttpx)
  set(HAVE_MRUBY      ${WITH_MRUBY})
  set(HAVE_NEVERBLEED ${WITH_NEVERBLEED})
else()
  set(HAVE_MRUBY 0)
  set(HAVE_NEVERBLEED 0)
endif()

# Checks for header files.
include(CheckIncludeFile)
check_include_file("arpa/inet.h"    HAVE_ARPA_INET_H)
check_include_file("fcntl.h"        HAVE_FCNTL_H)
check_include_file("inttypes.h"     HAVE_INTTYPES_H)
check_include_file("limits.h"       HAVE_LIMITS_H)
check_include_file("netdb.h"        HAVE_NETDB_H)
check_include_file("netinet/in.h"   HAVE_NETINET_IN_H)
check_include_file("pwd.h"          HAVE_PWD_H)
check_include_file("sys/socket.h"   HAVE_SYS_SOCKET_H)
check_include_file("sys/time.h"     HAVE_SYS_TIME_H)
check_include_file("syslog.h"       HAVE_SYSLOG_H)
check_include_file("time.h"         HAVE_TIME_H)
check_include_file("unistd.h"       HAVE_UNISTD_H)

include(CheckTypeSize)
# Checks for typedefs, structures, and compiler characteristics.
# AC_TYPE_SIZE_T
check_type_size("ssize_t" SIZEOF_SSIZE_T)
if(SIZEOF_SSIZE_T STREQUAL "")
  # ssize_t is a signed type in POSIX storing at least -1.
  # Set it to "int" to match the behavior of AC_TYPE_SSIZE_T (autotools).
  set(ssize_t int)
endif()
# AC_TYPE_UINT8_T
# AC_TYPE_UINT16_T
# AC_TYPE_UINT32_T
# AC_TYPE_UINT64_T
# AC_TYPE_INT8_T
# AC_TYPE_INT16_T
# AC_TYPE_INT32_T
# AC_TYPE_INT64_T
# AC_TYPE_OFF_T
# AC_TYPE_PID_T
# AC_TYPE_UID_T
# XXX To support inline for crappy compilers, see https://cmake.org/Wiki/CMakeTestInline
# AC_C_INLINE
# XXX is AC_SYS_LARGEFILE still needed for modern systems?
# add_definitions(-D_FILE_OFFSET_BITS=64)

include(CheckStructHasMember)
check_struct_has_member("struct tm" tm_gmtoff time.h HAVE_STRUCT_TM_TM_GMTOFF)

# Check size of pointer to decide we need 8 bytes alignment adjustment.
check_type_size("int *"   SIZEOF_INT_P)
check_type_size("time_t"  SIZEOF_TIME_T)

# Checks for library functions.
include(CheckFunctionExists)
check_function_exists(_Exit     HAVE__EXIT)
check_function_exists(accept4   HAVE_ACCEPT4)

# timerfd_create was added in linux kernel 2.6.25
include(CheckSymbolExists)
# XXX does this correctly detect initgroups (un)availability on cygwin?
check_symbol_exists(initgroups grp.h HAVE_DECL_INITGROUPS)
if(NOT HAVE_DECL_INITGROUPS AND HAVE_UNISTD_H)
  # FreeBSD declares initgroups() in unistd.h
  check_symbol_exists(initgroups unistd.h HAVE_DECL_INITGROUPS2)
  if(HAVE_DECL_INITGROUPS2)
    set(HAVE_DECL_INITGROUPS 1)
  endif()
endif()

check_function_exists(timerfd_create HAVE_TIMERFD_CREATE)
# Checks for epoll availability, primarily for examples/tiny-nghttpd
check_symbol_exists(epoll_create sys/epoll.h HAVE_EPOLL)
if(HAVE_EPOLL AND HAVE_TIMERFD_CREATE)
  set(ENABLE_TINY_NGHTTPD 1)
endif()

set(WARNCFLAGS)
set(WARNCXXFLAGS)
if(CMAKE_C_COMPILER_ID MATCHES "MSVC")
  if(ENABLE_WERROR)
    set(WARNCFLAGS    /WX)
    set(WARNCXXFLAGS  /WX)
  endif()
else()
  if(ENABLE_WERROR)
    extract_valid_c_flags(WARNCFLAGS    -Werror)
    extract_valid_c_flags(WARNCXXFLAGS  -Werror)
  endif()

  # For C compiler
  extract_valid_c_flags(WARNCFLAGS
    -Wall
    -Wextra
    -Wmissing-prototypes
    -Wstrict-prototypes
    -Wmissing-declarations
    -Wpointer-arith
    -Wdeclaration-after-statement
    -Wformat-security
    -Wwrite-strings
    -Wshadow
    -Winline
    -Wnested-externs
    -Wfloat-equal
    -Wundef
    -Wendif-labels
    -Wempty-body
    -Wcast-align
    -Wclobbered

=== Makefile ===
#
# Copyright (C) 2003 Christophe Varoqui, <christophe.varoqui@opensvc.com>
#

#
# Try to supply the linux kernel headers.
#
ifeq ($(KRNLSRC),)
	KRNLLIB = /lib/modules/$(shell uname -r)
	ifeq ($(shell test -r $(KRNLLIB)/source && echo 1),1)
		KRNLSRC = $(KRNLLIB)/source
		KRNLOBJ = $(KRNLLIB)/build
	else
		KRNLSRC = $(KRNLLIB)/build
		KRNLOBJ = $(KRNLLIB)/build
	endif
endif

ifeq ($(MULTIPATH_VERSION),)
	VERSION = $(shell basename ${PWD} | cut -d'-' -f3)
else
	VERSION = $(MULTIPATH_VERSION)
endif

export KRNLSRC
export KRNLOBJ

BUILDDIRS = \
	libmpathcmd \
	libmultipath \
	libmultipath/prioritizers \
	libmultipath/checkers \
	libmpathpersist \
	multipath \
	multipathd \
	mpathpersist \
	kpartx

all: recurse

recurse:
	@for dir in $(BUILDDIRS); do \
	$(MAKE) -C $$dir VERSION=$(VERSION) \
		KRNLSRC=$(KRNLSRC) KRNLOBJ=$(KRNLOBJ) || exit $?; \
	done

recurse_clean:
	@for dir in $(BUILDDIRS); do \
	$(MAKE) -C $$dir clean || exit $?; \
	done

recurse_install:
	@for dir in $(BUILDDIRS); do \
	$(MAKE) -C $$dir install || exit $?; \
	done

recurse_uninstall:
	@for dir in $(BUILDDIRS); do \
	$(MAKE) -C $$dir uninstall || exit $?; \
	done

clean: recurse_clean

install: recurse_install

uninstall: recurse_uninstall

.PHONY:	TAGS
TAGS:
	etags -a libmultipath/*.c
	etags -a libmultipath/*.h
	etags -a multipathd/*.c
	etags -a multipathd/*.h

=== apt-pkg/CMakeLists.txt ===
# Include apt-pkg directly, as some files have #include <system.h>
include_directories(${PROJECT_BINARY_DIR}/include/apt-pkg)

add_definitions("-DAPT_PKG_EXPOSE_STRING_VIEW")

# Set the version of the library
execute_process(COMMAND awk -v ORS=. "/^\#define APT_PKG_M/ {print \$3}"
                COMMAND sed "s/\\.\$//"
                INPUT_FILE ${CMAKE_CURRENT_SOURCE_DIR}/contrib/macros.h
                OUTPUT_VARIABLE MAJOR OUTPUT_STRIP_TRAILING_WHITESPACE)
execute_process(COMMAND grep "^#define APT_PKG_RELEASE"
                COMMAND cut -d " " -f 3
                INPUT_FILE ${CMAKE_CURRENT_SOURCE_DIR}/contrib/macros.h
                OUTPUT_VARIABLE MINOR OUTPUT_STRIP_TRAILING_WHITESPACE)

message(STATUS "Building libapt-pkg ${MAJOR} (release ${MINOR})")
set(APT_PKG_MAJOR ${MAJOR} PARENT_SCOPE) # exporting for methods/CMakeLists.txt

# Definition of the C++ files used to build the library
file(GLOB_RECURSE library "*.cc")
file(GLOB_RECURSE headers "*.h")

# Create a library using the C++ files
add_library(apt-pkg SHARED ${library})
add_dependencies(apt-pkg apt-pkg-versionscript)
# Link the library and set the SONAME
target_include_directories(apt-pkg
                           PRIVATE ${ZLIB_INCLUDE_DIRS}
                                   ${BZIP2_INCLUDE_DIR}
                                   ${LZMA_INCLUDE_DIRS}
                                   ${LZ4_INCLUDE_DIRS}
                                   ${ICONV_INCLUDE_DIRS}
)

target_link_libraries(apt-pkg
                      PRIVATE -lutil ${CMAKE_DL_LIBS} ${RESOLV_LIBRARIES}
                             ${CMAKE_THREAD_LIBS_INIT}
                             ${ZLIB_LIBRARIES}
                             ${BZIP2_LIBRARIES}
                             ${LZMA_LIBRARIES}
                             ${LZ4_LIBRARIES}
                             ${ICONV_LIBRARIES}
)
set_target_properties(apt-pkg PROPERTIES VERSION ${MAJOR}.${MINOR})
set_target_properties(apt-pkg PROPERTIES SOVERSION ${MAJOR})
add_version_script(apt-pkg)

# Install the library and the header files
install(TARGETS apt-pkg LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR})
install(FILES ${headers} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/apt-pkg)
flatify(${PROJECT_BINARY_DIR}/include/apt-pkg/ "${headers}")

if(CMAKE_BUILD_TYPE STREQUAL "Coverage")
  target_link_libraries(apt-pkg PUBLIC noprofile)
endif()

=== kpartx/Makefile ===
#
# Copyright (C) 2003 Christophe Varoqui, <christophe.varoqui@opensvc.com>
#
include ../Makefile.inc

CFLAGS += -I. -D_LARGEFILE64_SOURCE -D_FILE_OFFSET_BITS=64

LDFLAGS = -ldevmapper

LIBDM_API_COOKIE = $(shell grep -Ecs '^[a-z]*[[:space:]]+dm_task_set_cookie' /usr/include/libdevmapper.h)

ifneq ($(strip $(LIBDM_API_COOKIE)),0)
	CFLAGS += -DLIBDM_API_COOKIE
endif

OBJS = bsd.o dos.o kpartx.o solaris.o unixware.o dasd.o sun.o \
	gpt.o mac.o ps3.o crc32.o lopart.o xstrncpy.o devmapper.o

EXEC = kpartx

all: $(EXEC)

$(EXEC): $(OBJS)
	$(CC) $(OBJS) -o $(EXEC) $(LDFLAGS)
	$(GZIP) $(EXEC).8 > $(EXEC).8.gz

install: $(EXEC) $(EXEC).8
	$(INSTALL_PROGRAM) -d $(DESTDIR)$(bindir)
	$(INSTALL_PROGRAM) -m 755 $(EXEC) $(DESTDIR)$(bindir)
	$(INSTALL_PROGRAM) -d $(DESTDIR)$(libudevdir)
	$(INSTALL_PROGRAM) -m 755 kpartx_id $(DESTDIR)$(libudevdir)
	$(INSTALL_PROGRAM) -d $(DESTDIR)$(libudevdir)/rules.d
	$(INSTALL_PROGRAM) -m 644 kpartx.rules $(DESTDIR)$(libudevdir)/rules.d/66-kpartx.rules
	$(INSTALL_PROGRAM) -d $(DESTDIR)$(mandir)
	$(INSTALL_PROGRAM) -m 644 $(EXEC).8.gz $(DESTDIR)$(mandir)

uninstall:
	$(RM) $(DESTDIR)$(bindir)/$(EXEC)
	$(RM) $(DESTDIR)$(mandir)/$(EXEC).8.gz
	$(RM) $(DESTDIR)$(libudevdir)/kpartx_id
	$(RM) $(DESTDIR)$(libudevdir)/rules.d/66-kpartx.rules
	$(RM) $(DESTDIR)$(libudevdir)/rules.d/67-kpartx-compat.rules

clean:
	$(RM) core *.o $(EXEC) *.gz

=== lib/CMakeLists.txt ===
add_subdirectory(includes)

include_directories(
  "${CMAKE_CURRENT_SOURCE_DIR}/includes"
  "${CMAKE_CURRENT_BINARY_DIR}/includes"
)

add_definitions(-DBUILDING_NGHTTP2)

set(NGHTTP2_SOURCES
  nghttp2_pq.c nghttp2_map.c nghttp2_queue.c
  nghttp2_frame.c
  nghttp2_buf.c
  nghttp2_stream.c nghttp2_outbound_item.c
  nghttp2_session.c nghttp2_submit.c
  nghttp2_helper.c
  nghttp2_npn.c
  nghttp2_hd.c nghttp2_hd_huffman.c nghttp2_hd_huffman_data.c
  nghttp2_version.c
  nghttp2_priority_spec.c
  nghttp2_option.c
  nghttp2_callbacks.c
  nghttp2_mem.c
  nghttp2_http.c
  nghttp2_rcbuf.c
  nghttp2_debug.c
)

# Public shared library
add_library(nghttp2 SHARED ${NGHTTP2_SOURCES})
set_target_properties(nghttp2 PROPERTIES
  COMPILE_FLAGS "${WARNCFLAGS}"
  VERSION ${LT_VERSION} SOVERSION ${LT_SOVERSION}
  C_VISIBILITY_PRESET hidden
)

if(HAVE_CUNIT)
  # Static library (for unittests because of symbol visibility)
  add_library(nghttp2_static STATIC ${NGHTTP2_SOURCES})
  set_target_properties(nghttp2_static PROPERTIES
    COMPILE_FLAGS "${WARNCFLAGS}"
    VERSION ${LT_VERSION} SOVERSION ${LT_SOVERSION}
    ARCHIVE_OUTPUT_NAME nghttp2
  )
  target_compile_definitions(nghttp2_static PUBLIC "-DNGHTTP2_STATICLIB")
endif()

install(TARGETS nghttp2
  DESTINATION "${CMAKE_INSTALL_LIBDIR}")

install(FILES "${CMAKE_CURRENT_BINARY_DIR}/libnghttp2.pc"
  DESTINATION "${CMAKE_INSTALL_LIBDIR}/pkgconfig")

=== libmpathpersist/Makefile ===
include ../Makefile.inc

SONAME = 0
DEVLIB = libmpathpersist.so
LIBS = $(DEVLIB).$(SONAME)

CFLAGS += -I$(multipathdir) -I$(mpathpersistdir) -I$(mpathcmddir)

LIBDEPS += -lpthread -ldevmapper -ldl -L$(multipathdir) -lmultipath \
	   -L$(mpathcmddir) -lmpathcmd

OBJS = mpath_persist.o mpath_updatepr.o mpath_pr_ioctl.o

all: $(LIBS)

$(LIBS):
	$(CC) -c $(CFLAGS) *.c
	$(CC) $(SHARED_FLAGS) $(LIBDEPS) -Wl,-soname=$@ $(CFLAGS) -o $@ $(OBJS)
	$(LN) $(LIBS) $(DEVLIB)
	$(GZIP) mpath_persistent_reserve_in.3 > mpath_persistent_reserve_in.3.gz
	$(GZIP) mpath_persistent_reserve_out.3 > mpath_persistent_reserve_out.3.gz

install: $(LIBS)
	$(INSTALL_PROGRAM) -d $(DESTDIR)$(syslibdir)
	$(INSTALL_PROGRAM) -m 755 $(LIBS) $(DESTDIR)$(syslibdir)/$(LIBS)
	$(INSTALL_PROGRAM) -m 755 -d $(DESTDIR)$(syslibdir)
	$(INSTALL_PROGRAM) -m 755 -d $(DESTDIR)$(man3dir)
	$(INSTALL_PROGRAM) -m 755 -d $(DESTDIR)$(incdir)
	$(LN) $(LIBS) $(DESTDIR)$(syslibdir)/$(DEVLIB)
	$(INSTALL_PROGRAM) -m 644 mpath_persistent_reserve_in.3.gz $(DESTDIR)$(man3dir)
	$(INSTALL_PROGRAM) -m 644 mpath_persistent_reserve_out.3.gz $(DESTDIR)$(man3dir)
	$(INSTALL_PROGRAM) -m 644 mpath_persist.h $(DESTDIR)$(incdir)

uninstall:
	$(RM) $(DESTDIR)$(syslibdir)/$(LIBS)
	$(RM) $(DESTDIR)$(man3dir)/mpath_persistent_reserve_in.3.gz
	$(RM) $(DESTDIR)$(man3dir)/mpath_persistent_reserve_out.3.gz
	$(RM) $(DESTDIR)$(incdir)/mpath_persist.h
	$(RM) $(DESTDIR)$(syslibdir)/$(DEVLIB)

clean:
	$(RM) core *.a *.o *.so *.so.* *.gz

=== libmultipath/Makefile ===
#
# Copyright (C) 2003 Christophe Varoqui, <christophe.varoqui@opensvc.com>
#
include ../Makefile.inc

SONAME = 0
DEVLIB = libmultipath.so
LIBS = $(DEVLIB).$(SONAME)

CFLAGS += -I$(mpathcmddir)

LIBDEPS = -lpthread -ldl -ldevmapper -ludev -L$(mpathcmddir) -lmpathcmd

ifdef SYSTEMD
	CFLAGS += -DUSE_SYSTEMD=$(SYSTEMD)
	ifeq ($(shell test $(SYSTEMD) -gt 209 && echo 1), 1)
		LIBDEPS += -lsystemd
	else
		LIBDEPS += -lsystemd-daemon
	endif
endif

LIBDM_API_FLUSH = $(shell grep -Ecs '^[a-z]*[[:space:]]+dm_task_no_flush' /usr/include/libdevmapper.h)

ifneq ($(strip $(LIBDM_API_FLUSH)),0)
	CFLAGS += -DLIBDM_API_FLUSH -D_GNU_SOURCE
endif

LIBDM_API_COOKIE = $(shell grep -Ecs '^[a-z]*[[:space:]]+dm_task_set_cookie' /usr/include/libdevmapper.h)

ifneq ($(strip $(LIBDM_API_COOKIE)),0)
	CFLAGS += -DLIBDM_API_COOKIE
endif

LIBUDEV_API_RECVBUF = $(shell grep -Ecs '^[a-z]*[[:space:]]+udev_monitor_set_receive_buffer_size' /usr/include/libudev.h)

ifneq ($(strip $(LIBUDEV_API_RECVBUF)),0)
	CFLAGS += -DLIBUDEV_API_RECVBUF
endif

LIBDM_API_DEFERRED = $(shell grep -Ecs '^[a-z]*[[:space:]]+dm_task_deferred_remove' /usr/include/libdevmapper.h)

ifneq ($(strip $(LIBDM_API_DEFERRED)),0)
	CFLAGS += -DLIBDM_API_DEFERRED
endif

OBJS = memory.o parser.o vector.o devmapper.o callout.o \
	hwtable.o blacklist.o util.o dmparser.o config.o \
	structs.o discovery.o propsel.o dict.o \
	pgpolicies.o debug.o defaults.o uevent.o \
	switchgroup.o uxsock.o print.o alias.o log_pthread.o \
	log.o configure.o structs_vec.o sysfs.o prio.o checkers.o \
	lock.o waiter.o file.o wwids.o prioritizers/alua_rtpg.o

all: $(LIBS)

$(LIBS): $(OBJS)
	$(CC) $(LDFLAGS) $(SHARED_FLAGS) -Wl,-soname=$@ $(CFLAGS) -o $@ $(OBJS) $(LIBDEPS)
	$(LN) $@ $(DEVLIB)

install:
	$(INSTALL_PROGRAM) -d $(DESTDIR)$(syslibdir)
	$(INSTALL_PROGRAM) -m 755 $(LIBS) $(DESTDIR)$(syslibdir)/$(LIBS)
	$(INSTALL_PROGRAM) -m 755 -d $(DESTDIR)$(libdir)
	$(LN) $(LIBS) $(DESTDIR)$(syslibdir)/$(DEVLIB)

uninstall:
	$(RM) $(DESTDIR)$(syslibdir)/$(LIBS)
	$(RM) $(DESTDIR)$(syslibdir)/$(DEVLIB)

clean:
	$(RM) core *.a *.o *.so *.so.* *.gz

=== man/Makefile ===
#
# man/Makefile	man/ Makefile for the net-tools Package
#
# NET-TOOLS	A collection of programs that form the base set of the
#		NET-3 Networking Distribution for the LINUX operating
#		system.
#
# Version:	Makefile 0.03 (2000-10-08)
#
# Authors:	Bernd Eckenfels <net-tools@lina.inka.de>
#               Arnaldo Carvalhoa de Melo <acme@conectiva.com.br>
#		Copyright 1995-1996 Bernd Eckebnfels, Germany
#                              1998 Arnaldo Carvalho de Melo, Brazil
#
#960322	{0.01}	Bernd Eckenfels:	creation to make main Makefile cleaner
#980701	{0.02}	Arnaldo C. Melo:	making the main Makefile *more* cleaner :)
#001008 {0.03}  Bernd Eckenfels:	RH patch for FHS (man page now in mandir)
#
#
#	This program is free software; you can redistribute it
#	and/or  modify it under  the terms of  the GNU General
#	Public  License as  published  by  the  Free  Software
#	Foundation;  either  version 2 of the License, or  (at
#	your option) any later version.
#

INSTALL=install
mandir=/usr/share/man

-include ../config.make
ifeq ($(I18N),1)
ALL_LANGS = $(filter-out Makefile,$(wildcard *))
ifeq ($(LINGUAS),)
LANGS = $(ALL_LANGS)
else
LANGS = $(sort $(filter $(LINGUAS),$(ALL_LANGS)) en_US)
endif
else
LANGS = en_US
endif

all:

clean:
		rm -f -- DEADJOE *~ *.orig
		rm -f -- */DEADJOE */*~ */*.orig

clobber:	clean

install:
		LANGS='$(LANGS)' ; \
		for LANG in $$LANGS; do \
			cd $$LANG; \
			for SECTION in 1 5 8; do \
				if [ "$$LANG" = "en_US" ] ; then \
					MAN_DIR=${BASEDIR}${mandir}/man$$SECTION; \
				else \
					MAN_DIR=${BASEDIR}${mandir}/$$LANG/man$$SECTION; \
				fi ; \
				CMDS=`ls *.$$SECTION`; \
				[ -z "$$CMDS" ] && continue; \
				$(INSTALL) -d -m 755 $$MAN_DIR; \
				for CMD in $$CMDS; do \
					$(INSTALL) -m 644 $$CMD $$MAN_DIR; \
				done; \
			done; \
			cd ..; \
		done

# End of man/Makefile.

=== mpathpersist/Makefile ===
include ../Makefile.inc

CFLAGS += -I$(multipathdir) -I$(mpathpersistdir)

LDFLAGS += -lpthread -ldevmapper -L$(mpathpersistdir) -lmpathpersist \
	   -L$(multipathdir) -L$(mpathcmddir) -lmpathcmd -lmultipath -ludev

EXEC = mpathpersist

OBJS = main.o

all: $(EXEC)

$(EXEC): $(OBJS)
	$(CC) -g $(OBJS) -o $(EXEC) $(LDFLAGS) $(CFLAGS)
	$(GZIP) $(EXEC).8 > $(EXEC).8.gz

install:
	$(INSTALL_PROGRAM) -d $(DESTDIR)$(bindir)
	$(INSTALL_PROGRAM) -m 755 $(EXEC) $(DESTDIR)$(bindir)/
	$(INSTALL_PROGRAM) -d $(DESTDIR)$(mandir)
	$(INSTALL_PROGRAM) -m 644 $(EXEC).8.gz $(DESTDIR)$(mandir)

clean:
	$(RM) core *.o $(EXEC) *.gz

uninstall:
	$(RM) $(DESTDIR)$(bindir)/$(EXEC)
	$(RM) $(DESTDIR)$(mandir)/$(EXEC).8.gz

=== multipath/Makefile ===
#
# Copyright (C) 2003 Christophe Varoqui, <christophe.varoqui@opensvc.com>
#
include ../Makefile.inc

CFLAGS += -I$(multipathdir) -I$(mpathcmddir)

LDFLAGS += -lpthread -ldevmapper -ldl -L$(multipathdir) -lmultipath -ludev \
	   -L$(mpathcmddir) -lmpathcmd

EXEC = multipath

OBJS = main.o

all: $(EXEC)

$(EXEC): $(OBJS)
	$(CC) $(CFLAGS) $(OBJS) -o $(EXEC) $(LDFLAGS)
	$(GZIP) $(EXEC).8 > $(EXEC).8.gz
	$(GZIP) $(EXEC).conf.5 > $(EXEC).conf.5.gz

install:
	$(INSTALL_PROGRAM) -d $(DESTDIR)$(bindir)
	$(INSTALL_PROGRAM) -m 755 $(EXEC) $(DESTDIR)$(bindir)/
	$(INSTALL_PROGRAM) -d $(DESTDIR)$(udevrulesdir)
	$(INSTALL_PROGRAM) -m 644 11-dm-mpath.rules $(DESTDIR)$(udevrulesdir)
	$(INSTALL_PROGRAM) -m 644 $(EXEC).rules $(DESTDIR)$(libudevdir)/rules.d/56-multipath.rules
	$(INSTALL_PROGRAM) -d $(DESTDIR)$(mandir)
	$(INSTALL_PROGRAM) -m 644 $(EXEC).8.gz $(DESTDIR)$(mandir)
	$(INSTALL_PROGRAM) -d $(DESTDIR)$(man5dir)
	$(INSTALL_PROGRAM) -m 644 $(EXEC).conf.5.gz $(DESTDIR)$(man5dir)

uninstall:
	$(RM) $(DESTDIR)$(bindir)/$(EXEC)
	$(RM) $(DESTDIR)$(udevrulesdir)/11-dm-mpath.rules
	$(RM) $(DESTDIR)$(libudevdir)/rules.d/56-multipath.rules
	$(RM) $(DESTDIR)$(mandir)/$(EXEC).8.gz
	$(RM) $(DESTDIR)$(man5dir)/$(EXEC).conf.5.gz

clean:
	$(RM) core *.o $(EXEC) *.gz

=== multipathd/Makefile ===
include ../Makefile.inc

#
# debuging stuff
#
#CFLAGS += -DLCKDBG
#CFLAGS += -D_DEBUG_
#CFLAGS += -DLOGDBG
CFLAGS += -I$(multipathdir) -I$(mpathpersistdir) -I$(mpathcmddir)

LDFLAGS += -ludev -ldl -L$(multipathdir) -lmultipath -L$(mpathpersistdir) \
	   -lmpathpersist -L$(mpathcmddir) -lmpathcmd -lurcu -lpthread \
	   -ldevmapper -lreadline

ifdef SYSTEMD
	CFLAGS += -DUSE_SYSTEMD=$(SYSTEMD)
	ifeq ($(shell test $(SYSTEMD) -gt 209 && echo 1), 1)
		LDFLAGS += -lsystemd
	else
		LDFLAGS += -lsystemd-daemon
	endif
endif

OBJS = main.o pidfile.o uxlsnr.o uxclnt.o cli.o cli_handlers.o

EXEC = multipathd

all : $(EXEC)

$(EXEC): $(OBJS)
	$(CC) $(CFLAGS) $(OBJS) $(LDFLAGS) -o $(EXEC)
	$(GZIP) $(EXEC).8 > $(EXEC).8.gz

install:
	$(INSTALL_PROGRAM) -d $(DESTDIR)$(bindir)
	$(INSTALL_PROGRAM) -m 755 $(EXEC) $(DESTDIR)$(bindir)
ifdef SYSTEMD
	$(INSTALL_PROGRAM) -d $(DESTDIR)$(unitdir)
	$(INSTALL_PROGRAM) -m 644 $(EXEC).service $(DESTDIR)$(unitdir)
	$(INSTALL_PROGRAM) -m 644 $(EXEC).socket $(DESTDIR)$(unitdir)
endif
	$(INSTALL_PROGRAM) -d $(DESTDIR)$(mandir)
	$(INSTALL_PROGRAM) -m 644 $(EXEC).8.gz $(DESTDIR)$(mandir)

uninstall:
	$(RM) $(DESTDIR)$(bindir)/$(EXEC)
	$(RM) $(DESTDIR)$(mandir)/$(EXEC).8.gz
	$(RM) $(DESTDIR)$(unitdir)/$(EXEC).service
	$(RM) $(DESTDIR)$(unitdir)/$(EXEC).socket

clean:
	$(RM) core *.o $(EXEC) *.gz

=== src/CMakeLists.txt ===
add_subdirectory(includes)

file(GLOB c_sources *.c)
set_source_files_properties(${c_sources} PROPERTIES
  COMPILE_FLAGS "${WARNCFLAGS}")
file(GLOB cxx_sources *.cc)
set_source_files_properties(${cxx_sources} PROPERTIES
  COMPILE_FLAGS "${WARNCXXFLAGS} ${CXX1XCXXFLAGS}")

include_directories(
  "${CMAKE_SOURCE_DIR}/lib/includes"
  "${CMAKE_BINARY_DIR}/lib/includes"
  "${CMAKE_SOURCE_DIR}/lib"
  "${CMAKE_SOURCE_DIR}/src/includes"
  "${CMAKE_SOURCE_DIR}/third-party"

  ${JEMALLOC_INCLUDE_DIRS}
  ${SPDYLAY_INCLUDE_DIRS}
  ${LIBXML2_INCLUDE_DIRS}
  ${LIBEV_INCLUDE_DIRS}
  ${OPENSSL_INCLUDE_DIRS}
  ${JANSSON_INCLUDE_DIRS}
  ${ZLIB_INCLUDE_DIRS}
)

# XXX per-target?
link_libraries(
  nghttp2
  ${JEMALLOC_LIBRARIES}
  ${SPDYLAY_LIBRARIES}
  ${LIBXML2_LIBRARIES}
  ${LIBEV_LIBRARIES}
  ${OPENSSL_LIBRARIES}
  ${JANSSON_LIBRARIES}
  ${ZLIB_LIBRARIES}
  ${APP_LIBRARIES}
)

if(ENABLE_APP)
  set(HELPER_OBJECTS
    util.cc
    http2.cc timegm.c app_helper.cc nghttp2_gzip.c
  )

  # nghttp client
  set(NGHTTP_SOURCES
    ${HELPER_OBJECTS}
    nghttp.cc
    ssl.cc
  )
  if(HAVE_LIBXML2)
    list(APPEND NGHTTP_SOURCES HtmlParser.cc)
  endif()

  # nghttpd
  set(NGHTTPD_SOURCES
    ${HELPER_OBJECTS}
    nghttpd.cc
    ssl.cc
    HttpServer.cc
  )

  # h2load
  set(H2LOAD_SOURCES
    util.cc
    http2.cc h2load.cc
    timegm.c
    ssl.cc
    h2load_http2_session.cc
    h2load_http1_session.cc
  )
  if(HAVE_SPDYLAY)
    list(APPEND H2LOAD_SOURCES
      h2load_spdy_session.cc
    )
  endif()


  # Common libnhttpx sources (used for nghttpx and unit tests)
  set(NGHTTPX_SRCS
    util.cc http2.cc timegm.c
    app_helper.cc
    ssl.cc
    shrpx_config.cc
    shrpx_accept_handler.cc
    shrpx_connection_handler.cc
    shrpx_client_handler.cc
    shrpx_http2_upstream.cc
    shrpx_https_upstream.cc
    shrpx_downstream.cc
    shrpx_downstream_connection.cc
    shrpx_http_downstream_connection.cc
    shrpx_http2_downstream_connection.cc
    shrpx_http2_session.cc
    shrpx_downstream_queue.cc
    shrpx_log.cc
    shrpx_http.cc
    shrpx_io_control.cc
    shrpx_ssl.cc
    shrpx_worker.cc
    shrpx_log_config.cc
    shrpx_connect_blocker.cc
    shrpx_live_check.cc
    shrpx_downstream_connection_pool.cc
    shrpx_rate_limit.cc
    shrpx_connection.cc
    shrpx_memcached_dispatcher.cc
    shrpx_memcached_connection.cc
    shrpx_worker_process.cc
    shrpx_signal.cc
    shrpx_router.cc
    shrpx_api_downstream_connection.cc
    shrpx_health_monitor_downstream_connection.cc
    shrpx_exec.cc
    xsi_strerror.c
  )
  if(HAVE_SPDYLAY)
    list(APPEND NGHTTPX_SRCS
      shrpx_spdy_upstream.cc
    )
  endif()
  if(HAVE_MRUBY)
    list(APPEND NGHTTPX_SRCS
      shrpx_mruby.cc
      shrpx_mruby_module.cc
      shrpx_mruby_module_env.cc
      shrpx_mruby_module_request.cc
      shrpx_mruby_module_response.cc
    )
  endif()
  add_library(nghttpx_static STATIC ${NGHTTPX_SRCS})
  set_target_properties(nghttpx_static PROPERTIES ARCHIVE_OUTPUT_NAME nghttpx)

  set(NGHTTPX-bin_SOURCES
    shrpx.cc
  )

  if(HAVE_MRUBY)
    target_link_libraries(nghttpx_static mruby-lib)
  endif()

  if(HAVE_NEVERBLEED)
    target_link_libraries(nghttpx_static neverbleed)
  endif()


  if(HAVE_CUNIT)
    set(NGHTTPX_UNITTEST_SOURCES
      shrpx-unittest.cc
      shrpx_ssl_test.cc
      shrpx_downstream_test.cc
      shrpx_config_test.cc
      shrpx_worker_test.cc
      shrpx_http_test.cc
      shrpx_router_test.cc
      http2_test.cc
      util_test.cc
      nghttp2_gzip_test.c
      nghttp2_gzip.c
      buffer_test.cc
      memchunk_test.cc
      template_test.cc
      base64_test.cc
    )
    add_executable(nghttpx-unittest EXCLUDE_FROM_ALL
      ${NGHTTPX_UNITTEST_SOURCES}
      $<TARGET_OBJECTS:http-parser>
    )
    target_include_directories(nghttpx-unittest PRIVATE ${CUNIT_INCLUDE_DIRS})
    target_compile_definitions(nghttpx-unittest
      PRIVATE "-DNGHTTP2_SRC_DIR=\"${CMAKE_SOURCE_DIR}/src\""
    )
    target_link_libraries(nghttpx-unittest nghttpx_static ${CUNIT_LIBRARIES})
    if(HAVE_MRUBY)
      target_link_libraries(nghttpx-unittest mruby-lib)
    endif()
    if(HAVE_NEVERBLEED)
      target_link_libraries(nghttpx-unittest neverbleed)
    endif()

    add_test(nghttpx-unittest nghttpx-unittest)
    add_dependencies(check nghttpx-unittest)
  endif()

  add_executable(nghttp   ${NGHTTP_SOURCES}   $<TARGET_OBJECTS:http-parser>)
  add_executable(nghttpd  ${NGHTTPD_SOURCES}  $<TARGET_OBJECTS:http-parser>)
  add_executable(nghttpx  ${NGHTTPX-bin_SOURCES} $<TARGET_OBJECTS:http-parser>)
  target_compile_definitions(nghttpx PRIVATE "-DPKGDATADIR=\"${PKGDATADIR}\"")
  target_link_libraries(nghttpx nghttpx_static)
  add_executable(h2load   ${H2LOAD_SOURCES}   $<TARGET_OBJECTS:http-parser>)

  install(TARGETS nghttp nghttpd nghttpx h2load
    RUNTIME DESTINATION "${CMAKE_INSTALL_BINDIR}")
endif()

if(ENABLE_HPACK_TOOLS)
  set(inflatehd_SOURCES
    inflatehd.cc
    comp_helper.c
  )
  set(deflatehd_SOURCES
    deflatehd.cc
    comp_helper.c
  )
  add_executable(inflatehd ${inflatehd_SOURCES})
  add_executable(deflatehd ${deflatehd_SOURCES})
  install(TARGETS inflatehd deflatehd
    RUNTIME DESTINATION "${CMAKE_INSTALL_BINDIR}")
endif()

if(ENABLE_ASIO_LIB)
  set(NGHTTP2_ASIO_SOURCES
    util.cc http2.cc
    ssl.cc
    timegm.c
    asio_common.cc
    asio_io_service_pool.cc
    asio_server_http2.cc
    asio_server_http2_impl.cc
    asio_server.cc
    asio_server_http2_handler.cc
    asio_server_request.cc
    asio_server_request_impl.cc
    asio_server_response.cc
    asio_server_response_impl.cc
    asio_server_stream.cc
    asio_server_serve_mux.cc
    asio_server_request_handler.cc
    asio_server_tls_context.cc
    asio_client_session.cc
    asio_client_session_impl.cc
    asio_client_session_tcp_impl.cc
    asio_client_session_tls_impl.cc
    asio_client_response.cc
    asio_client_response_impl.cc
    asio_client_request.cc
    asio_client_request_impl.cc
    asio_client_stream.cc
    asio_client_tls_context.cc
  )

  add_library(nghttp2_asio SHARED
     ${NGHTTP2_ASIO_SOURCES}
     $<TARGET_OBJECTS:http-parser>
  )
  target_include_directories(nghttp2_asio PRIVATE
    ${OPENSSL_INCLUDE_DIRS}
    ${Boost_INCLUDE_DIRS}
  )
  target_link_libraries(nghttp2_asio
    nghttp2
    ${OPENSSL_LIBRARIES}
    ${Boost_LIBRARIES}
  )
  set_target_properties(nghttp2_asio PROPERTIES
    VERSION 1.0.0 SOVERSION 1)

  install(TARGETS nghttp2_asio
    DESTINATION "${CMAKE_INSTALL_LIBDIR}")

  install(FILES "${CMAKE_CURRENT_BINARY_DIR}/libnghttp2_asio.pc"
    DESTINATION "${CMAKE_INSTALL_LIBDIR}/pkgconfig")
endif()

=== changelog ===
glibc (2.24-5) unstable; urgency=medium

  [ Aurelien Jarno ]
  * debian/sysdeps/linux.mk: fix cross-compilation by also looking at headers
    in $(LINUX_HEADERS).
  * debian/testsuite-xfail-debian.mk: allow nptl/tst-stack4 to fail on HPPA.

  [ Samuel Thibault ]
  * hurd-i386/cvs-libpthread-static-weak.diff: New patch to fix weak
    references when linking in libpthread statically.
  * hurd-i386/cvs-pthread-atfork.diff: New patch to fix unregistering atfork
    handlers at library unload. Closes: #841068.
  * debhelper.in/libc-dev.install.hurd-i386: Install libpthread_nonshared.a.

 -- Aurelien Jarno <aurel32@debian.org>  Tue, 18 Oct 2016 23:10:46 +0200

glibc (2.24-4) unstable; urgency=medium

  [ Samuel Thibault ]
  * hurd-i386/tg-hurdsig-SA_SIGINFO.diff: Fix preemptors and thus
    hurd_safe_*.
  * hurd-i386/tg-hurdsig-fixes.diff: Fix uninitialized value.
  * hurd-i386/submitted-exec_filename.diff: Add missing includes, fix const
    warning.
  * hurd-i386/cvs-mallocfork.diff: New patch to fix concurrency between
    hurd_malloc and fork, triggered by malloc/tst-malloc-fork-deadlock.
  * hurd-i386/cvs-libpthread.diff: Update to latest upstream version.
    Closes: #839742.
  * hurd-i386/libpthread_build.diff: Refresh.
  * hurd-i386/libpthread_version.diff: Refresh.
  * hurd-i386/unsubmitted-libc_alloca_cutoff.diff: Refresh.
  * hurd-i386/cvs-hidden.diff: Drop, merged upstream.
  * hurd-i386/cvs-libpthread-2.23.diff: Drop, merged upstream.
  * hurd-i386/cvs-libpthread-api.diff: Drop, merged upstream.
  * hurd-i386/cvs-libpthread_build.diff: Drop, merged upstream.
  * hurd-i386/cvs-libpthread_clean2.diff: Drop, merged upstream.
  * hurd-i386/cvs-pt-kill.diff: Drop, merged upstream.
  * hurd-i386/libpthread-versions.diff: Drop, merged upstream.
  * hurd-i386/libpthread_clean.diff: Drop, merged upstream.
  * hurd-i386/libpthread_sigmask.diff: Drop, merged upstream.
  * hurd-i386/libpthread_spin-lock.diff: Drop, merged upstream.
  * hurd-i386/unsubmitted-libpthread-semaphore.h.diff: Drop, merged upstream.
  * hurd-i386/tg-pthread_deps.diff: New patch, fixes references to libc
    symbols.
  * testsuite-xfail-debian.mk: Clear fixed hurd-i386 test.
  * control: Drop hurd dependency from libc-bin: the reason for the dep has
    disappeared.
  * hurd-i386/unsubmitted-libc_alloca_cutoff.diff: Rename to
    hurd-i386/tg-allocalim.diff.
  * hurd-i386/unsubmitted-timer_routines.diff: Rename to
    hurd-i386/tg-timer_routines.diff.
  * hurd-i386/tg-glibc-2.24-restore-malloc-hook.diff: Restore malloc_hook for
    now for mach-defpager.
  * hurd-i386/cvs-setcancelstate.diff: New patch to work around a bug with
    newer libpthread snapshot.

  [ Adam Conrad ]
  * debian/rules.d/tarball.mk: Apply --no-renames to make the diff readable.
  * debian/rules.d/tarball.mk: Avoid filterdiff bugs with git pathspec magic.
  * debian/patches/git-updates.diff: Update to 2.24 master to test the above.

  [ John David Anglin ]
  * debian/patches/hppa/cvs-atomic-machine.diff: New patch from upstream to
    fix nptl/tst-stack4 on hppa.  Closes: #838574.

  [ Aurelien Jarno ]
  * debian/sysdeps/linux.mk: Install both kernel and library headers symlinks
    using a single for loop.
  * debian/sysdeps/linux.mk: Also install a /usr/include/<triplet>/arch
    symlink if it exists, needed for the tilegx architecture.
  * debian/control.in/main: add a dependency on lsb-base (>= 3.0-6) for ncsd.
  * debian/debhelper.in/nscd.init: also invalidate services and netgroup
    during reload.  Closes: #793649.
  * debian/control.in/main, debian/rules.d/debhelper.mk: install nscd systemd
    files. Closes: #767707.
  * debian/patches/localedata/locale-C.diff: switch back transliterations to
    combining.  Closes: #840199.
  * debian/debhelper.in/locales.postinst: improve locales-all detection.
    Closes: #840901.
  * debian/patches/i386/local-cpuid-level2.diff: replace by upstream patch
    cvs-cpuid-level2.diff.
  * debian/control.in/main: slightly relax the build-dependency on g++-6 to
    make lintian happy.

 -- Aurelien Jarno <aurel32@debian.org>  Sun, 16 Oct 2016 13:06:08 +0200

glibc (2.24-3) unstable; urgency=medium

  [ Aurelien Jarno ]
  * patches/kfreebsd/local-sysdeps.diff: update to revision 6102 (from
    glibc-bsd).
  * debian/control.in/main: Drop "Provides: locales" for locales-all.
    Closes: #837694.
  * Mark libc-l10n as Multi-Arch: foreign.

  [ Samuel Thibault ]
  * hurd-i386/tg-poll_errors_fixes.diff: Fix spurious port destroy on io_select
    returning an error.
  * hurd-i386/cvs-libpthread.diff: Update from upstream. Fixes spurious
    dependencies of libp11, libgnutls30, libbsd0.

  [ John David Anglin ]
  * patches/hppa/submitted-sysdeps-cancel.diff: new patch to fix syscall
    cancellation issues.  Closes: #837518.
  * testsuite-xfail-debian.mk: HPPA updates.

 -- Aurelien Jarno <aurel32@debian.org>  Sat, 17 Sep 2016 20:00:44 +0200

glibc (2.24-2) unstable; urgency=medium

  [ Samuel Thibault ]
  * hurd-i386/tg-gsync-libc.diff: Fix for glibc 2.24.
  * testsuite-xfail-debian.mk: Update header conformance results.

  [ Aurelien Jarno ]
  * debian/rules.d/debhelper.mk: remove the arch-qualifier from the
    linux-libc-dev depends.  Closes: #836446.
  * debian/patches/any/submitted-perl-inc.diff: new patch to fix the
    testsuite with perl (>= 5.22.2-4), which removed '.' from @INC by
    default.
  * debian/patches/git-updates.diff: update from upstream stable branch.

 -- Aurelien Jarno <aurel32@debian.org>  Sat, 03 Sep 2016 22:36:31 +0200

glibc (2.24-1) unstable; urgency=medium

  [ Adam Conrad ]
  * debian/rules.d/control.mk: Manually add binutils, linux-libc-dev, and the
    current GCC to the rebuild test deps, so they land in Testsuite-Triggers.

  [ Aurelien Jarno ]
  * debian/patches/git-updates.diff: update from upstream stable branch:
    - debian/patches/any/submitted-argp-attribute.diff: upstreamed.
    - Fix backtrace hang on armel/armhf, possibly causing a minor


=== debian/changelog ===
dpkg (1.18.15) unstable; urgency=medium

  [ Guillem Jover ]
  * Improve PIE flags support:
    - Do not enable PIE when linking static programs. glibc-based systems
      do not support this combination and produce very bogus output.
      Proposed by Szabolcs Nagy <nsz@port70.net>. Closes: #843714
  * On source builds add 'source' to the Architecture field in the
    .buildinfo file in dpkg-genbuildinfo.
  * Add new Build-Date field to .buildinfo files.
  * Generate deterministic .buildinfo filenames in dpkg-genbuildinfo,
    following the same pattern as used for .changes files.
  * Bump .buildinfo Format to version 0.2.
  * Change dpkg-buildpackage -j and -J on “auto” mode to fallback to serial
    execution when we cannot infer the number of online processors on
    unsupported or exotic systems. This should be a safer mode of operation.
    Proposed by Simon McVittie <smcv@debian.org>.
  * Only preallocate disk size in dpkg for unpacked files bigger than 16 KiB.
    Closes: #824636
  * Perl modules:
    - Validate architecture arguments in Dpkg::Deps deps_parse().
      Prompted by Johannes Schauer <josch@debian.org>.
  * Documentation:
    - Escape dashes in field names in dpkg-buildinfo(1).
  * Test suite:
    - Mark partially documented POD modules as TAP TODO.

  [ Updated man pages translations ]
  * German (Helge Kreutzmann).

 -- Guillem Jover <guillem@debian.org>  Wed, 16 Nov 2016 03:28:05 +0100

dpkg (1.18.14) unstable; urgency=medium

  [ Guillem Jover ]
  * Improve PIE flags support:
    - Rename the spec name cc1_options to self_spec.
      Suggested by James Clarke <jrtc27@jrtc27.com>
    - Do not set PIE options if they have been negated, and do not reset
      them if they have been requested.
    Closes: #843791, #843826
  * Fix use after free error in dpkg. It was trying to print messages that
    had already been freed as part of the database memory pool, causing in
    some cases segfaults when reporting the error summary at the end.
    Regression introduced in dpkg 1.18.11. Closes: #843874
  * Change default color behavior to auto.
  * Perl modules:
    - Fix confusing date parse error message in Dpkg::Changelog::Entry::Debian
      when the date contains “May”. Closes: #843829
      Thanks to Nishanth Aravamudan <nish.aravamudan@canonical.com>.
    - New module Dpkg::Build::Info module refactored from dpkg-genbuildinfo.
      Requested by Johannes Schauer <josch@debian.org>.
  * Documentation:
    - Improve the DEB_BUILD_OPTIONS description in dpkg-buildpackage(1).
      And mention the parallel option there.
    - Explicitly mention in dpkg-buildpackage(1) that setting the number
      of parallel jobs to 1, restores the serial behavior.
      Prompted by Thorsten Glaser <t.glaser@tarent.de>.
  * Packaging:
    - List public Dpkg::Control::Tests module in libdpkg-perl description.
  * Test suite:
    - Do not fail tests on missing fakeroot, just skip them.
  * Build system:
    - Fix inversion logic in libmd configure check when requested explicitly.
    - Do not consider the compressor libraries available in configure if the
      headers are not usable.
    - Fix DPKG_BUILD_RELEASE_DATE to require DPKG_PROG_PERL, as it uses perl.
    - Change DPKG_BUILD_RELEASE_DATE to use perl instead of date(1) to
      format the timestamp, as the former is more portable.

  [ Updated man pages translations ]
  * German (Helge Kreutzmann).

 -- Guillem Jover <guillem@debian.org>  Fri, 11 Nov 2016 02:26:08 +0100

dpkg (1.18.13) unstable; urgency=medium

  * Improve PIE flags support:
    - Retroactively document in the changelog that PIE is enabled by default
      on all supported architectures regardless of gcc doing so itself on a
      subset of them.
    - When emitting PIE flags on architectures where gcc does not inject
      those itself, do it via a specs file too, so that maintainers can
      use them unconditionally regardless of the object being compiled
      or linked.
    - When injecting -no-pie for linking via the gcc specs file also
      inject -fno-PIE.
    - Update the documentation.
  * Perl modules:
    - Do not try to load non-files in Dpkg::Dist::Files load_dir method.
      Fixes test failures on non-Linux architectures. Closes: #843436
  * Packaging:
    - Add missing Breaks on old libdpkg-perl to dpkg. Closes: #843429
      Thanks to Sven Joachim <svenjoac@gmx.de>.
    - Ship deb-src-files(5) man page in dpkg-dev.
  * Build system:
    - Use deterministic dates for generated man pages. Closes: #843469
      Thanks to Reiner Herrmann <reiner@reiner-h.de>.

 -- Guillem Jover <guillem@debian.org>  Mon, 07 Nov 2016 03:28:42 +0100

dpkg (1.18.12) unstable; urgency=medium

  * Build system:
    - Set umask to 0022 for functional test suite.
  * Documentation:
    - Rename FILE FORMATS section to FILES in dpkg-source(1).
    - Use "dpkg suite" as the manual item in man pages .TH macro.
    - Use %VERSION% in dpkg-statoverride(1) source item in man page .TH macro.
    - Document environment variables used by source format modules in
      dpkg-source(1).

 -- Guillem Jover <guillem@debian.org>  Sun, 06 Nov 2016 05:36:20 +0100

dpkg (1.18.11) unstable; urgency=medium

  [ Guillem Jover ]
  * Make dpkg-maintscript-helper conffile commands more robust. Check that
    conffile pathname arguments are absolute paths and verify version number
    to be valid. Thanks to David Kalnischkies <david@kalnischkies.de>.
  * Add support to dpkg-scanpackages for scanning a single binary file.
    Thanks to Javier Serrano Polo <javier@jasp.net>. Closes: #833964
  * Obsolete dpkg-deb bzip2 and lzma compression methods by emitting errors.
  * Remove obsolete dpkg-deb --old and --new options.
  * Remove obsolete dpkg --print-installation-architecture option.
  * Fix dpkg error messages when parsing md5sum files to include the package
    name affected.
  * Do not emit epochs for unambiguous versions in deb-split package header.
    Regression introduced in dpkg 1.18.0.


=== package/debian/changelog ===
ncurses6 (6.0+20160917) unstable; urgency=low

  * latest weekly patch

 -- Thomas E. Dickey <dickey@invisible-island.net>  Sat, 17 Sep 2016 09:25:35 -0400

ncurses6 (5.9-20120608) unstable; urgency=low

  * initial release

 -- Thomas E. Dickey <dickey@invisible-island.net>  Fri, 08 Jun 2012 07:54:29 -0400

=== control ===
Source: boost1.61
Homepage: http://www.boost.org/
Section: libs
Priority: optional
Maintainer: Debian Boost Team <pkg-boost-devel@lists.alioth.debian.org>
Uploaders: Steve M. Robbins <smr@debian.org>
Build-Depends: debhelper (>= 9), dpkg-dev (>= 1.16.1~), dctrl-tools,
 zlib1g-dev, libbz2-dev, libicu-dev (>= 57), mpi-default-dev,
 bison, flex, docbook-to-man, help2man, xsltproc, doxygen, 
 dh-python,
 g++ (>= 4:5-0), g++-6,
 python, python-all-dev, 
 python3, python3-all-dev (>= 3.1)
Build-Conflicts: libopenmpi-dev (= 1.3.2-2)
Vcs-Browser: http://anonscm.debian.org/viewvc/pkg-boost/boost/
Vcs-Svn: svn://anonscm.debian.org/pkg-boost/boost/
Standards-Version: 3.9.8

Package: libboost1.61-dbg
Architecture: any
Multi-Arch: same
Section: debug
Priority: extra
Depends: ${misc:Depends}, ${shlibs:Depends}, libboost1.61-dev (= ${binary:Version})
Conflicts: libboost1.42-dbg, libboost1.46-dbg, libboost1.48-dbg, libboost1.49-dbg, libboost1.50-dbg, libboost1.52-dbg, libboost1.53-dbg, libboost1.54-dbg, libboost1.55-dbg, libboost1.57-dbg, libboost1.58-dbg, libboost1.60-dbg
Description: Boost C++ Libraries with debug symbols
 This package forms part of the Boost C++ Libraries collection.
 .
 These libraries are built with debug symbols. They are useful to debug
 programs which use Boost. These must be used also at build/link time.

Package: libboost1.61-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: ${misc:Depends}, ${shlibs:Depends}, libstdc++-4.8-dev | libstdc++-dev
Suggests: libboost1.61-doc,
 libboost-atomic1.61-dev,
 libboost-chrono1.61-dev,
 libboost-context1.61-dev [any-i386 any-amd64 armel armhf arm64 mips mipsel powerpc ppc64el],
 libboost-coroutine1.61-dev [any-i386 any-amd64 armel armhf arm64 mips mipsel powerpc ppc64el],
 libboost-date-time1.61-dev,
 libboost-exception1.61-dev,
 libboost-filesystem1.61-dev,
 libboost-graph1.61-dev,
 libboost-graph-parallel1.61-dev,
 libboost-iostreams1.61-dev,
 libboost-locale1.61-dev,
 libboost-log1.61-dev,
 libboost-math1.61-dev,
 libboost-mpi1.61-dev,
 libboost-mpi-python1.61-dev,
 libboost-program-options1.61-dev,
 libboost-python1.61-dev,
 libboost-random1.61-dev,
 libboost-regex1.61-dev,
 libboost-serialization1.61-dev,
 libboost-signals1.61-dev,
 libboost-system1.61-dev,
 libboost-test1.61-dev,
 libboost-thread1.61-dev,
 libboost-timer1.61-dev,
 libboost-wave1.61-dev,
 libboost1.61-tools-dev,
 libmpfrc++-dev, libntl-dev
Conflicts: bjam, boost-build, libboost1.42-dev, libboost1.46-dev, libboost1.48-dev, libboost1.49-dev, libboost1.50-dev, libboost1.52-dev, libboost1.53-dev, libboost1.54-dev, libboost1.55-dev, libboost1.57-dev, libboost1.58-dev, libboost1.60-dev
Description: Boost C++ Libraries development files
 The Boost web site provides free, peer-reviewed, portable C++ source
 libraries. The emphasis is on libraries which work well with the C++
 Standard Library. One goal is to establish "existing practice" and
 provide reference implementations so that the Boost libraries are
 suitable for eventual standardization. Some of the libraries have
 already been proposed for inclusion in the C++ Standards Committee's
 upcoming C++ Standard Library Technical Report.
 .
 This package provides headers for all Boost libraries.
 .
 Extended precision arithmetic package libmpfrc++-dev or libntl-dev is
 required to use the Boost.Multiprecision wrapping of the respective
 library.
 .
 For the following subprojects separate packages exist: chrono,
 date-time, exception filesystem, graph, iostreams, locale, math, mpi,
 program_options, python, regex, serialization, signals, system, test,
 thread, timer, and wave.

Package: libboost1.61-tools-dev
Architecture: any
Multi-Arch: foreign
Section: libdevel
Depends: ${misc:Depends}, ${shlibs:Depends}
Suggests: xsltproc,
 doxygen,
 docbook-xml (>= 4.2),
 docbook-xsl (>= 1.73.2),
 default-jdk (>= 1.4),
 fop (>= 0.94)
Conflicts: bjam, boost-build, libboost1.49-dev, libboost1.53-tools-dev, libboost1.54-tools-dev, libboost1.55-tools-dev, libboost1.57-tools-dev, libboost1.58-tools-dev, libboost1.60-tools-dev
Replaces: bjam, boost-build, libboost1.49-dev, libboost1.53-dev, libboost1.53-tools-dev
Description: Boost C++ Libraries development tools
 The Boost web site provides free, peer-reviewed, portable C++ source
 libraries. The emphasis is on libraries which work well with the C++
 Standard Library. One goal is to establish "existing practice" and
 provide reference implementations so that the Boost libraries are
 suitable for eventual standardization. Some of the libraries have
 already been proposed for inclusion in the C++ Standards Committee's
 upcoming C++ Standard Library Technical Report.
 .
 This package provides the auxiliary tools bjam, Boost.Build, bcp,
 inspect, boostbook and quickbook.

Package: libboost1.61-all-dev
Architecture: any
Section: libdevel
Depends: ${misc:Depends},
 libboost1.61-dev,
 libboost1.61-tools-dev,
 libboost-atomic1.61-dev,
 libboost-chrono1.61-dev,
 libboost-context1.61-dev [any-i386 any-amd64 armel armhf arm64 mips mipsel powerpc ppc64el],
 libboost-coroutine1.61-dev [any-i386 any-amd64 armel armhf arm64 mips mipsel powerpc ppc64el],
 libboost-date-time1.61-dev,
 libboost-exception1.61-dev,
 libboost-filesystem1.61-dev,
 libboost-graph1.61-dev,
 libboost-graph-parallel1.61-dev,
 libboost-iostreams1.61-dev,
 libboost-locale1.61-dev,
 libboost-log1.61-dev,
 libboost-math1.61-dev,
 libboost-mpi1.61-dev,
 libboost-mpi-python1.61-dev,
 libboost-program-options1.61-dev,
 libboost-python1.61-dev,
 libboost-random1.61-dev,
 libboost-regex1.61-dev,
 libboost-serialization1.61-dev,
 libboost-signals1.61-dev,
 libboost-system1.61-dev,
 libboost-test1.61-dev,
 libboost-thread1.61-dev,
 libboost-timer1.61-dev,
 libboost-wave1.61-dev
Description: Boost C++ Libraries development files (ALL)
 The Boost web site provides free, peer-reviewed, portable C++ source
 libraries. The emphasis is on libraries which work well with the C++
 Standard Library. One goal is to establish "existing practice" and
 provide reference implementations so that the Boost libraries are
 suitable for eventual standardization. Some of the libraries have
 already been proposed for inclusion in the C++ Standards Committee's
 upcoming C++ Standard Library Technical Report.
 .
 This metapackage provides the complete Boost development environment,
 including all separately-packaged libraries.

Package: libboost1.61-doc
Homepage: http://www.boost.org/libs/
Architecture: all
Section: doc
Depends: ${misc:Depends}
Suggests: libboost1.61-dev (>= ${source:Version})
Conflicts: libboost1.42-doc, libboost1.46-doc, libboost1.48-doc, libboost1.49-doc, libboost1.50-doc, libboost1.52-doc, libboost1.53-doc, libboost1.54-doc, libboost1.55-doc, libboost1.57-doc, libboost1.58-doc, libboost1.60-doc
Description: Boost.org libraries documentation
 The Boost web site provides free, peer-reviewed, portable C++ source
 libraries. The emphasis is on libraries which work well with the C++
 Standard Library. One goal is to establish "existing practice" and
 provide reference implementations so that the Boost libraries are
 suitable for eventual standardization. Some of the libraries have
 already been proposed for inclusion in the C++ Standards Committee's
 upcoming C++ Standard Library Technical Report.
 .
 This is documentation for the boost libraries in HTML format.
 Some pages point to header files provided in the corresponding -dev package,
 so it is suggested to install the latter as well.

Package: libboost-atomic1.61.0
Homepage: http://www.boost.org/libs/atomic/
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: atomic data types, operations, and memory ordering constraints
 This package forms part of the Boost C++ Libraries collection.
 .
 Boost.Atomic is a library that provides atomic data types and
 operations on these data types, as well as memory ordering
 constraints required for coordinating multiple threads through atomic
 variables. It implements the interface as defined by the C++11
 standard, but makes this feature available for platforms lacking
 system/compiler support for this particular C++11 feature.
 .
 Users of this library should already be familiar with concurrency in
 general, as well as elementary concepts such as "mutual exclusion".
 .
 The implementation makes use of processor-specific instructions where
 possible (via inline assembler, platform libraries or compiler
 intrinsics), and falls back to "emulating" atomic operations through
 locking.

Package: libboost-atomic1.61-dev
Homepage: http://www.boost.org/libs/atomic/
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: ${misc:Depends},
 libboost1.61-dev (= ${binary:Version}),
 libboost-atomic1.61.0 (= ${binary:Version})
Description: atomic data types, operations, and memory ordering constraints
 This package forms part of the Boost C++ Libraries collection.
 .
 Boost.Atomic is a library that provides atomic data types and
 operations on these data types, as well as memory ordering
 constraints required for coordinating multiple threads through atomic
 variables. It implements the interface as defined by the C++11
 standard, but makes this feature available for platforms lacking
 system/compiler support for this particular C++11 feature.
 .
 Users of this library should already be familiar with concurrency in
 general, as well as elementary concepts such as "mutual exclusion".
 .
 The implementation makes use of processor-specific instructions where
 possible (via inline assembler, platform libraries or compiler
 intrinsics), and falls back to "emulating" atomic operations through
 locking.
Conflicts: libboost-atomic1.53-dev, libboost-atomic1.54-dev, libboost-atomic1.55-dev, libboost-atomic1.57-dev, libboost-atomic1.58-dev, libboost-atomic1.60-dev

Package: libboost-chrono1.61.0
Homepage: http://www.boost.org/libs/chrono/
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: C++ representation of time duration, time point, and clocks
 This package forms part of the Boost C++ Libraries collection.
 .
 The Boost.Chrono library provides:
 .
  * A means to represent time durations: managed by the generic duration
    class.Examples of time durations include days, minutes, seconds and
    nanoseconds, which can be represented with a fixed number of clock
    ticks per unit. All of these units of time duration are united with
    a generic interface by the duration facility.
  * A type for representing points in time: time_point. A time_point
    represents an epoch plus or minus a duration. The library leaves
    epochs unspecified. A time_point is associated with a clock.
  * Several clocks, some of which may not be available on a particular
    platform: system_clock, steady_clock and high_resolution_clock. A
    clock is a pairing of a time_point and duration, and a function
    which returns a time_point representing now.
 .
 To make the timing facilities more generally useful, Boost.Chrono
 provides a number of clocks that are thin wrappers around the
 operating system's time APIs, thereby allowing the extraction of wall
 clock time, user CPU time, system CPU time spent by the process:
 .
  * process_real_cpu_clock, captures wall clock CPU time spent by the
    current process.
  * process_user_cpu_clock, captures user-CPU time spent by the current
    process.
  * process_system_cpu_clock, captures system-CPU time spent by the
    current process.
  * a tuple-like class process_cpu_clock, that captures real, user-CPU,
    and system-CPU process times together.
  * a thread_clock thread steady clock giving the time spent by the
    current thread (when supported by a platform).
 .
 Lastly, Boost.Chrono includes typeof registration for duration and
 time_point to permit using emulated auto with C++03 compilers.

Package: libboost-chrono1.61-dev

=== debian/control ===
Source: linux-signed
Section: kernel
Priority: optional
Maintainer: Debian Kernel Team <debian-kernel@lists.debian.org>
Uploaders: Ben Hutchings <ben@decadent.org.uk>
Standards-Version: 3.9.6
Build-Depends: debhelper (>= 9.20151004~), rsync, sbsigntool [amd64 arm64 armhf i386], kernel-wedge (>= 2.93~), linux-kbuild-4.8, linux-support-4.8.0-1 (= 4.8.7-1), linux-image-4.8.0-1-amd64-unsigned (= 4.8.7-1) [amd64], linux-image-4.8.0-1-rt-amd64-unsigned (= 4.8.7-1) [amd64], linux-image-4.8.0-1-arm64-unsigned (= 4.8.7-1) [arm64], linux-image-4.8.0-1-armmp-unsigned (= 4.8.7-1) [armhf], linux-image-4.8.0-1-armmp-lpae-unsigned (= 4.8.7-1) [armhf], linux-image-4.8.0-1-686-unsigned (= 4.8.7-1) [i386], linux-image-4.8.0-1-686-pae-unsigned (= 4.8.7-1) [i386], linux-image-4.8.0-1-rt-686-pae-unsigned (= 4.8.7-1) [i386], linux-image-4.8.0-1-powerpc-unsigned (= 4.8.7-1) [powerpc], linux-image-4.8.0-1-powerpc-smp-unsigned (= 4.8.7-1) [powerpc], linux-image-4.8.0-1-powerpc64-unsigned (= 4.8.7-1) [powerpc], linux-image-4.8.0-1-powerpc64le-unsigned (= 4.8.7-1) [ppc64el], linux-image-4.8.0-1-s390x-unsigned (= 4.8.7-1) [s390x]
Homepage: https://www.kernel.org/
Vcs-Browser: https://anonscm.debian.org/cgit/kernel/linux-signed.git
Vcs-Git: https://anonscm.debian.org/git/kernel/linux-signed.git

Package: kernel-image-4.8.0-1-amd64-di
Architecture: amd64
Section: debian-installer
Priority: standard
Provides: kernel-image, zlib-modules
Description: Linux kernel image and core modules for the Debian installer
 This package contains the kernel image and core modules for the Debian
 installer boot images.  It does _not_ provide a usable kernel for your
 full Debian system.
Kernel-Version: 4.8.0-1-amd64
Package-Type: udeb

Package: nic-modules-4.8.0-1-amd64-di
Architecture: amd64
Section: debian-installer
Priority: standard
Provides: nic-modules, nic-extra-modules
Depends: kernel-image-4.8.0-1-amd64-di, nic-shared-modules-4.8.0-1-amd64-di, i2c-modules-4.8.0-1-amd64-di, crc-modules-4.8.0-1-amd64-di
Description: NIC drivers
 This package contains Ethernet and some paravirtualised network drivers
 for the kernel.
Kernel-Version: 4.8.0-1-amd64
Package-Type: udeb

Package: nic-wireless-modules-4.8.0-1-amd64-di
Architecture: amd64
Section: debian-installer
Priority: standard
Provides: nic-wireless-modules
Depends: kernel-image-4.8.0-1-amd64-di, nic-shared-modules-4.8.0-1-amd64-di, usb-modules-4.8.0-1-amd64-di, mmc-modules-4.8.0-1-amd64-di, pcmcia-modules-4.8.0-1-amd64-di, crc-modules-4.8.0-1-amd64-di
Description: Wireless NIC drivers
 This package contains wireless NIC drivers for the kernel.  Includes
 crypto modules only needed for wireless (WEP, WPA).
Kernel-Version: 4.8.0-1-amd64
Package-Type: udeb

Package: nic-shared-modules-4.8.0-1-amd64-di
Architecture: amd64
Section: debian-installer
Priority: standard
Provides: nic-shared-modules
Depends: kernel-image-4.8.0-1-amd64-di
Description: Shared NIC drivers
 This package contains NIC drivers needed by combinations of nic-modules,
 nic-pcmcia-modules, nic-usb-modules and nic-wireless-modules.
Kernel-Version: 4.8.0-1-amd64
Package-Type: udeb

Package: serial-modules-4.8.0-1-amd64-di
Architecture: amd64
Section: debian-installer
Priority: optional
Provides: serial-modules
Depends: kernel-image-4.8.0-1-amd64-di, pcmcia-modules-4.8.0-1-amd64-di
Description: Serial drivers
 This package contains serial drivers for the kernel.
Kernel-Version: 4.8.0-1-amd64
Package-Type: udeb

Package: usb-serial-modules-4.8.0-1-amd64-di
Architecture: amd64
Section: debian-installer
Priority: optional
Provides: usb-serial-modules
Depends: kernel-image-4.8.0-1-amd64-di, usb-modules-4.8.0-1-amd64-di
Description: USB serial drivers
 This package contains USB serial drivers for the kernel.
Kernel-Version: 4.8.0-1-amd64
Package-Type: udeb

Package: ppp-modules-4.8.0-1-amd64-di
Architecture: amd64
Section: debian-installer
Priority: optional
Provides: ppp-modules
Depends: kernel-image-4.8.0-1-amd64-di, serial-modules-4.8.0-1-amd64-di, crc-modules-4.8.0-1-amd64-di
Description: PPP drivers
 This package contains PPP drivers for the kernel.
Kernel-Version: 4.8.0-1-amd64
Package-Type: udeb

Package: pata-modules-4.8.0-1-amd64-di
Architecture: amd64
Section: debian-installer
Priority: standard
Provides: pata-modules
Depends: kernel-image-4.8.0-1-amd64-di, ata-modules-4.8.0-1-amd64-di
Description: PATA drivers
 This package contains PATA drivers for the kernel.
Kernel-Version: 4.8.0-1-amd64
Package-Type: udeb

Package: cdrom-core-modules-4.8.0-1-amd64-di
Architecture: amd64
Section: debian-installer
Priority: standard
Provides: cdrom-core-modules
Depends: kernel-image-4.8.0-1-amd64-di, scsi-core-modules-4.8.0-1-amd64-di, isofs-modules-4.8.0-1-amd64-di
Description: CDROM support
 This package contains core CDROM support for the kernel.
Kernel-Version: 4.8.0-1-amd64
Package-Type: udeb

Package: firewire-core-modules-4.8.0-1-amd64-di
Architecture: amd64
Section: debian-installer
Priority: standard
Provides: firewire-core-modules
Depends: kernel-image-4.8.0-1-amd64-di, scsi-core-modules-4.8.0-1-amd64-di, crc-modules-4.8.0-1-amd64-di
Description: Core FireWire drivers
 This package contains core FireWire drivers for the kernel.
Kernel-Version: 4.8.0-1-amd64
Package-Type: udeb

Package: scsi-core-modules-4.8.0-1-amd64-di
Architecture: amd64
Section: debian-installer
Priority: standard
Provides: scsi-core-modules
Depends: kernel-image-4.8.0-1-amd64-di
Description: Core SCSI subsystem
 This package contains the core SCSI subsystem for the kernel.
Kernel-Version: 4.8.0-1-amd64
Package-Type: udeb

Package: scsi-modules-4.8.0-1-amd64-di
Architecture: amd64
Section: debian-installer
Priority: standard
Provides: scsi-modules
Depends: kernel-image-4.8.0-1-amd64-di, scsi-core-modules-4.8.0-1-amd64-di, cdrom-core-modules-4.8.0-1-amd64-di, ata-modules-4.8.0-1-amd64-di
Description: SCSI drivers
 This package contains SCSI drivers for the kernel.
Kernel-Version: 4.8.0-1-amd64
Package-Type: udeb

Package: loop-modules-4.8.0-1-amd64-di
Architecture: amd64
Section: debian-installer
Priority: standard
Provides: loop-modules
Depends: kernel-image-4.8.0-1-amd64-di
Description: Loopback filesystem support
 This package contains loopback filesystem support for the kernel.
Kernel-Version: 4.8.0-1-amd64
Package-Type: udeb

Package: btrfs-modules-4.8.0-1-amd64-di
Architecture: amd64
Section: debian-installer
Priority: extra
Provides: btrfs-modules
Depends: kernel-image-4.8.0-1-amd64-di, crc-modules-4.8.0-1-amd64-di, md-modules-4.8.0-1-amd64-di
Description: BTRFS filesystem support
 This package contains the BTRFS filesystem module for the kernel.
Kernel-Version: 4.8.0-1-amd64
Package-Type: udeb

Package: ext4-modules-4.8.0-1-amd64-di
Architecture: amd64
Section: debian-installer
Priority: standard
Provides: ext4-modules, ext2-modules, ext3-modules
Depends: kernel-image-4.8.0-1-amd64-di, crc-modules-4.8.0-1-amd64-di
Description: ext2/ext3/ext4 filesystem support
 This package contains the ext4 filesystem module for the kernel, which
 also supports ext2 and ext3.
Kernel-Version: 4.8.0-1-amd64
Package-Type: udeb

Package: isofs-modules-4.8.0-1-amd64-di
Architecture: amd64
Section: debian-installer
Priority: standard
Provides: isofs-modules
Depends: kernel-image-4.8.0-1-amd64-di
Description: ISOFS filesystem support
 This package contains the ISOFS filesystem module for the kernel.
Kernel-Version: 4.8.0-1-amd64
Package-Type: udeb

Package: jfs-modules-4.8.0-1-amd64-di
Architecture: amd64
Section: debian-installer
Priority: standard
Provides: jfs-modules
Depends: kernel-image-4.8.0-1-amd64-di
Description: JFS filesystem support
 This package contains the JFS filesystem module for the kernel.
Kernel-Version: 4.8.0-1-amd64
Package-Type: udeb

Package: ntfs-modules-4.8.0-1-amd64-di
Architecture: amd64
Section: debian-installer
Priority: extra
Provides: ntfs-modules
Depends: kernel-image-4.8.0-1-amd64-di
Description: NTFS filesystem support
 This package contains the NTFS file system module for the kernel.
Kernel-Version: 4.8.0-1-amd64
Package-Type: udeb

Package: xfs-modules-4.8.0-1-amd64-di
Architecture: amd64
Section: debian-installer
Priority: standard
Provides: xfs-modules
Depends: kernel-image-4.8.0-1-amd64-di, crc-modules-4.8.0-1-amd64-di
Description: XFS filesystem support
 This package contains the XFS filesystem module for the kernel.
Kernel-Version: 4.8.0-1-amd64
Package-Type: udeb

Package: fat-modules-4.8.0-1-amd64-di
Architecture: amd64
Section: debian-installer
Priority: standard
Provides: fat-modules
Depends: kernel-image-4.8.0-1-amd64-di
Description: FAT filesystem support
 This package contains the FAT and VFAT filesystem modules for the kernel.
Kernel-Version: 4.8.0-1-amd64
Package-Type: udeb

Package: md-modules-4.8.0-1-amd64-di
Architecture: amd64
Section: debian-installer
Priority: extra
Provides: md-modules
Depends: kernel-image-4.8.0-1-amd64-di, crc-modules-4.8.0-1-amd64-di
Description: RAID and LVM support
 This package contains RAID and LVM modules for the kernel.
Kernel-Version: 4.8.0-1-amd64
Package-Type: udeb

Package: multipath-modules-4.8.0-1-amd64-di
Architecture: amd64
Section: debian-installer
Priority: extra
Provides: multipath-modules
Depends: kernel-image-4.8.0-1-amd64-di, md-modules-4.8.0-1-amd64-di, scsi-core-modules-4.8.0-1-amd64-di
Description: Multipath support
 This package contains DM-Multipath modules for the kernel.
Kernel-Version: 4.8.0-1-amd64
Package-Type: udeb

Package: usb-modules-4.8.0-1-amd64-di
Architecture: amd64
Section: debian-installer
Priority: extra
Provides: usb-modules
Depends: kernel-image-4.8.0-1-amd64-di
Description: USB support
 This package contains core USB drivers for the kernel.
Kernel-Version: 4.8.0-1-amd64
Package-Type: udeb

Package: usb-storage-modules-4.8.0-1-amd64-di
Architecture: amd64
Section: debian-installer
Priority: standard
Provides: usb-storage-modules
Depends: kernel-image-4.8.0-1-amd64-di, scsi-core-modules-4.8.0-1-amd64-di, usb-modules-4.8.0-1-amd64-di
Description: USB storage support
 This package contains the USB storage driver for the kernel.
Kernel-Version: 4.8.0-1-amd64
Package-Type: udeb

Package: pcmcia-storage-modules-4.8.0-1-amd64-di
Architecture: amd64
Section: debian-installer
Priority: standard
Provides: pcmcia-storage-modules
Depends: kernel-image-4.8.0-1-amd64-di, cdrom-core-modules-4.8.0-1-amd64-di, pcmcia-modules-4.8.0-1-amd64-di, ata-modules-4.8.0-1-amd64-di
Description: PCMCIA storage drivers
 This package contains PCMCIA storage drivers for the kernel.
Kernel-Version: 4.8.0-1-amd64
Package-Type: udeb

Package: fb-modules-4.8.0-1-amd64-di
Architecture: amd64
Section: debian-installer
Priority: extra
Provides: fb-modules
Depends: kernel-image-4.8.0-1-amd64-di, i2c-modules-4.8.0-1-amd64-di
Description: Frame buffer support
 This package contains Frame buffer drivers for the kernel.
Kernel-Version: 4.8.0-1-amd64
Package-Type: udeb

Package: input-modules-4.8.0-1-amd64-di
Architecture: amd64
Section: debian-installer
Priority: extra
Provides: input-modules
Depends: kernel-image-4.8.0-1-amd64-di, usb-modules-4.8.0-1-amd64-di, i2c-modules-4.8.0-1-amd64-di
Description: Input devices support
 This package contains input device drivers for the kernel.
Kernel-Version: 4.8.0-1-amd64
Package-Type: udeb

Package: event-modules-4.8.0-1-amd64-di
Architecture: amd64
Section: debian-installer
Priority: extra
Provides: event-modules
Depends: kernel-image-4.8.0-1-amd64-di
Description: Event support
 This package contains event drivers for the kernel.
Kernel-Version: 4.8.0-1-amd64
Package-Type: udeb

Package: mouse-modules-4.8.0-1-amd64-di
Architecture: amd64
Section: debian-installer
Priority: extra
Provides: mouse-modules
Depends: kernel-image-4.8.0-1-amd64-di, event-modules-4.8.0-1-amd64-di, input-modules-4.8.0-1-amd64-di, usb-modules-4.8.0-1-amd64-di
Description: Mouse support
 This package contains mouse drivers for the kernel.
Kernel-Version: 4.8.0-1-amd64
Package-Type: udeb

Package: nic-pcmcia-modules-4.8.0-1-amd64-di
Architecture: amd64

=== debian/rules ===
#!/usr/bin/make -f
# debian/rules for the dpkg suite.
# Copyright © 2004 Scott James Remnant <scott@netsplit.com>
# Copyright © 2006-2012 Guillem Jover <guillem@debian.org>

WFLAGS := -Wall -Wextra -Wno-unused-parameter -Wno-missing-field-initializers

# XXX: Stack Protector Strong is only available in gcc >= 4.9
cc_version = $(shell $(CC) -dumpversion 2>/dev/null)
cc_version_lt = $(shell dpkg --compare-versions "$(cc_version)" lt-nl "$(1)" && echo yes)
hardening_old = $(if $(call cc_version_lt,4.9),-stackprotectorstrong)

# Use the in-tree dpkg-buildflags
dpkg_buildflags = \
	DEB_BUILD_MAINT_OPTIONS="hardening=+all,$(hardening_old)" \
	DEB_CFLAGS_MAINT_APPEND="$(WFLAGS)" \
	DEB_CXXFLAGS_MAINT_APPEND="$(WFLAGS)" \
	$(CURDIR)/run-script scripts/dpkg-buildflags.pl

DEB_BUILD_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
DEB_HOST_GNU_TYPE   ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_HOST_ARCH_OS    ?= $(shell dpkg-architecture -qDEB_HOST_ARCH_OS)
DEB_HOST_MULTIARCH  ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

# Support cross-compiling.
ifeq ($(DEB_BUILD_GNU_TYPE), $(DEB_HOST_GNU_TYPE))
	confflags += --build=$(DEB_HOST_GNU_TYPE)
else
	confflags += --build=$(DEB_BUILD_GNU_TYPE) --host=$(DEB_HOST_GNU_TYPE)
endif

# Do not enable everything on all platforms.
ifeq ($(DEB_HOST_ARCH_OS),linux)
	confflags += --with-libselinux
endif
ifeq (,$(filter maintainer-build,$(DEB_BUILD_OPTIONS)))
	confflags += --disable-silent-rules
endif

# Enable parallel test suite
NUMJOBS = 1
ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
  NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
  MAKEFLAGS += -j$(NUMJOBS)
endif

D := $(CURDIR)/debian/tmp

# Create configure script if necessary, automake handles rebuilding it.
configure:
	dh_testdir

	autoreconf -v -i

# Configure the build tree
build-tree/config.status: configure
	dh_testdir

	install -d build-tree
	cd build-tree && ../configure $(confflags) \
		$(shell $(dpkg_buildflags) --export=configure) \
		--prefix=/usr \
		--mandir=\$${datadir}/man \
		--infodir=\$${datadir}/info \
		--sysconfdir=/etc \
		--sbindir=/sbin \
		--localstatedir=/var \
		--with-devlibdir=\$${prefix}/lib/$(DEB_HOST_MULTIARCH) \
		--without-libmd \
		--with-libz \
		--with-liblzma \
		--with-libbz2

# Build the package in build-tree
build-indep build-arch build: build-tree/config.status
	dh_testdir

	cd build-tree && $(MAKE)

# Run the test suites
check: build
	dh_testdir

ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	cd build-tree && $(MAKE) VERBOSE=1 TESTSUITEFLAGS=--verbose \
	                         TEST_PARALLEL=$(NUMJOBS) check
endif

# Install the package underneath debian/tmp
install: check
	dh_testdir
	dh_testroot
	dh_prep
	dh_installdirs

	cd build-tree && $(MAKE) DESTDIR=$(D) install

define dpkg-installmanl10n
for f in `sed -e 's:\*:*/*:' debian/$(1).manpages`; do \
	test -e $$f && \
	install -D $$f `echo $$f | sed -e 's:^debian/tmp:debian/$(1):'`; \
done
endef

# Put together the dpkg and dselect packages
binary-arch: install
	dh_testdir -a
	dh_testroot -a
	dh_install -a
	dh_installcron -a
	dh_installlogrotate -a
	dh_installchangelogs -a ChangeLog*
	dh_installdocs -a
	$(call dpkg-installmanl10n,dpkg)
	$(call dpkg-installmanl10n,dselect)
	dh_installman -a
	dh_link -a
	dh_lintian -a
	dh_strip -a
	dh_compress -a
	dh_fixperms -a
	dh_installdeb -a
	dh_shlibdeps -a
	dh_gencontrol -a
	dh_md5sums -a
	dh_builddeb -a

# Put together the dpkg-dev package
binary-indep: install
	dh_testdir -i
	dh_testroot -i
	dh_install -i
	dh_installcron -i
	dh_installchangelogs -i ChangeLog*
	dh_installdocs -i
	$(call dpkg-installmanl10n,dpkg-dev)
	dh_installman -i
	dh_link -i
	dh_lintian -i
	dh_perl -i
	dh_compress -i
	dh_fixperms -i
	dh_installdeb -i
	dh_gencontrol -i
	dh_md5sums -i
	dh_builddeb -i

binary: binary-arch binary-indep


# Clean up the mess we made
clean:
	dh_testdir

	[ ! -f Makefile ] || $(MAKE) distclean
	rm -rf build-tree
	dh_clean


.PHONY: build check install binary-arch binary-indep binary clean

=== rules ===
#!/usr/bin/make -f

#
# debian/rules for perl.
#
# Note that although this rules file currently invokes tools from dpkg-dev
# implemented in perl (such as dpkg-architecture and so on), it aspires
# to not use perl at all, so that a new architecture can easily be
# bootstrapped. This aspiration should be considered when changing this
# file.
#
# <http://lists.alioth.debian.org/pipermail/perl-maintainers/2012-January/002870.html>

# we use bash-specific functionality, at least "shopt -s globstar"
export SHELL = /bin/bash

# at least LOCALTIME_{MIN,MAX} are affected by this
export TZ=UTC

# Configure output is sorted and varies with LC_COLLATE
export LC_ALL=C

# use the timestamp from debian/changelog for Pod::Man generated man pages
# this may end up in dpkg-buildpackage eventually but it's not there yet
export SOURCE_DATE_EPOCH = $(shell date -d "$$(dpkg-parsechangelog -SDate)" +%s)

fullversion := $(shell /bin/bash debian/config.debian --full-version)
nextversion := $(shell /bin/bash debian/config.debian --next-version)
version     := $(shell /bin/bash debian/config.debian --version)
installtype := $(shell /bin/bash debian/config.debian --install-type)
test_target := $(shell /bin/bash debian/config.debian --test-target)
strip	    := $(shell /bin/bash debian/config.debian --strip)
archtriplet := $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
arch        := $(shell dpkg-architecture -qDEB_HOST_ARCH)
srcdir      := $(shell pwd)
packages    := $(shell sed -n 's/^Package: *//p' debian/control)
arch_pkgs   := $(shell sed -n '/^Package:/ { s/^Package: *//; h }; /^Architecture: any/ { x; p }' debian/control)
indep_pkgs  := $(shell sed -n '/^Package:/ { s/^Package: *//; h }; /^Architecture: all/ { x; p }' debian/control)
build_date  := $(shell dpkg-parsechangelog | sed -n -e 's/^Date: //p')
tmp	    = debian/tmp
bin         = $(tmp)/usr/bin
man         = $(tmp)/usr/share/man
lib         = $(tmp)/usr/lib/$(archtriplet)/perl/$(version)
share       = $(tmp)/usr/share/perl/$(version)
build	    = debian/build
debug       = $(build)/perl-debug/usr/lib/debug
patches     = debian/patches/series
patchlevel  = patchlevel-debian.h

# we put the generated config.sh files here
pcd         = $(tmp)/usr/lib/$(archtriplet)/perl/debian-config-data-$(fullversion)

# If nonempty, this will determine $Config{debian_abi} and Provides: entries
# (otherwise, the Provides: entries will be generated by debian/mkprovides)
perlabi =

checkdir    = test -d debian
checkroot   = test `id -u` -eq 0
checkperl   = $(SHELL) debian/checkperl

DEB_BUILD_GNU_TYPE      ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
DEB_HOST_GNU_TYPE       ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

OBJCOPY = $(DEB_HOST_GNU_TYPE)-objcopy
STRIP = $(DEB_HOST_GNU_TYPE)-strip

# Invoking PERL_TO_USE is expected to find its standard library
# without additional command line arguments, so include lib/ here
# in its definition.
ifeq ($(DEB_HOST_GNU_TYPE), $(DEB_BUILD_GNU_TYPE))
	PERL_TO_USE = $(srcdir)/perl.static -I $(srcdir)/lib
else
	PERL_TO_USE = $(shell which perl)
	export TIME_HIRES_DONT_RUN_PROBES=1
endif

# this may differ from $(fullversion) for release candidates and the like
package_upstream_version = $(shell dpkg-parsechangelog | \
        sed -ne 's/-[^-]\+$$//; s/^Version: *\([0-9]\+:\)*//p')

package_version = $(shell dpkg-parsechangelog | sed -n 's/^Version: *//p')

# this gets prepended to the patch names in patchlevel.h
patchprefix = DEBPKG:

# control file substitutions
subst_upstream = -VUpstream-Version=$(package_upstream_version)
subst_next_upstream = -VNext-Upstream-Version=$(nextversion)

ifeq (,$(perlabi))
subst_perlapi  = -Vperlapi:Provides="`$(PERL_TO_USE) debian/mkprovides`"
else
subst_perlapi  = -Vperlapi:Provides="perlapi-$(perlabi)"
endif

# for cpan/Compress-Raw-Zlib
export BUILD_ZLIB=False
export ZLIB_INCLUDE=/usr/include
export ZLIB_LIB=/usr/lib

# for cpan/Compress-Raw-Bzip2
export BUILD_BZIP2=0
export BZIP2_INCLUDE=/usr/include
export BZIP2_LIB=/usr/lib

build: build-stamp
install: install-stamp

build-arch: build
build-indep: build

build-stamp: $(patchlevel) perl.static perl.debug libperl.so.$(fullversion)
	touch $@

$(patchlevel): $(patches)
	$(checkdir)
	test -f $<	# maintainer sanity check
	debian/gen-patchlevel -p $(patchprefix) -v $(package_version) $< > $@
	# $patchlevel_date in perlbug is extracted from patchlevel.h mtime, let's set
	# it to highest mtime of Debian patches for build reproducibility
	patchdate=`debian/gen-patchlevel -d`; touch --date="@$$patchdate" patchlevel.h

perl.static:
	$(checkdir)
	rm -f libperl.so* # must be built last
	[ ! -f Makefile ] || $(MAKE) distclean
	[ -f $(patchlevel) ] || touch $(patchlevel)
	$(SHELL) debian/config.debian --static

	# stash generated config.sh
	cp config.sh config.sh.static

	$(MAKE) perl $(test_target)
	mv libperl.a libperl-static
	mv perl perl.static

ifeq ($(DEB_HOST_GNU_TYPE), $(DEB_BUILD_GNU_TYPE))
	# for the build log
	$(PERL_TO_USE) -Ilib -V
endif

	# save these for the perl-base package
	cp lib/Config.pm lib/Config.pm.static
	cp lib/Config_heavy.pl lib/Config_heavy.pl.static

perl.debug:
	$(checkdir)
	rm -f libperl.so* # must be built last
	[ ! -f Makefile ] || $(MAKE) distclean
	[ -f $(patchlevel) ] || touch $(patchlevel)
	$(SHELL) debian/config.debian --debug

	# stash generated config.sh
	cp config.sh config.sh.debug

	$(MAKE) perl
	mv perl perl.debug

libperl.so.$(fullversion):
	$(checkdir)
	[ ! -f Makefile ] || $(MAKE) distclean
	[ -f $(patchlevel) ] || touch $(patchlevel)
	$(SHELL) debian/config.debian --shared

	# stash generated config.sh
	cp config.sh config.sh.shared

	$(MAKE) SHRPLDFLAGS='$$(LDDLFLAGS) -Wl,-soname,libperl.so.$(version)' $@
	ln -s libperl.so.$(fullversion) libperl.so.$(version)
	ln -s libperl.so.$(version) libperl.so
	$(MAKE) all $(test_target) || { rm -f libperl.so*; exit 1; }

clean:
	$(checkdir)
	$(checkroot)
	test -f $(patches)	# maintainer sanity check
	[ ! -f Makefile ] || $(MAKE) distclean
	rm -rf config.over perl.static perl.debug libperl-static libperl.so* \
	    $(patchlevel) build-stamp install-stamp t/auto debian/shlibs.local \
	    debian/perl-base.shlibs debian/libperl$(version).shlibs \
	    build-miniperl build-generate_uudmap optdef.sh config.sh.* \
	    debian/substvars debian/files debian/list.tmp $(tmp) $(build)

install-stamp: build-stamp
	$(checkdir)
	$(checkroot)
	$(checkperl)
	rm -rf $(tmp) $(build)

	$(MAKE) install DESTDIR="$(tmp)"

	# these end up in the wrong place
	mv $(share)/Config.pm.static $(lib)
	mv $(share)/Config_heavy.pl.static $(lib)

	# switch man extensions to 1p and 3pm for vendor module installs
	$(PERL_TO_USE) -i -p \
	    -e 's/^(man1ext=).*/$$1'\''1p'\''/;' \
	    -e 's/^(man3ext=).*/$$1'\''3pm'\''/;' \
		$(lib)/Config.pm $(lib)/Config_heavy.pl \
		$(lib)/Config.pm.static $(lib)/Config_heavy.pl.static

ifeq (,$(perlabi))
else
	# add \$Config{debian_abi}
	sed -i -e "/version =>/i\    debian_abi => '$(perlabi)'," \
		$(lib)/Config.pm $(lib)/Config.pm.static
endif

	# avoid exposing the point release in libperl names, to
	# avoid unnecessary breakage
	# see #759989
	$(PERL_TO_USE) -i -p \
	    -e 's/^(libperl='\''libperl\.so)\.$(fullversion)'\''/$$1.$(version)'\''/' \
		$(lib)/Config.pm $(lib)/Config_heavy.pl \
		$(lib)/Config.pm.static $(lib)/Config_heavy.pl.static

	# remove dpkg-buildflags effects from %Config
	# see #657853
	if which dpkg-buildflags >/dev/null 2>&1; then \
		for flag in $(shell dpkg-buildflags --get CPPFLAGS) \
		         $(shell dpkg-buildflags --get CFLAGS); do \
			case "$$flag" in -fstack-protector) ;; \
			     *) export flag; $(PERL_TO_USE) -i -pe "/^(cc|cpp)flags/ and \
			          s/(['\s])\Q\$$ENV{flag}\E(['\s])/\1\2/ and s/  +/ /" \
		            $(lib)/Config.pm $(lib)/Config_heavy.pl \
		            $(lib)/Config.pm.static $(lib)/Config_heavy.pl.static ;; \
		    esac; done; \
		for flag in $(shell dpkg-buildflags --get LDFLAGS); do \
			export flag; $(PERL_TO_USE) -i -pe "/^ld(dl)?flags/ and \

=== tests/control ===
Tests: timedated, hostnamed, localed-locale, localed-x11-keymap
Depends: systemd,
  libpam-systemd,
  acl,
  locales,
Restrictions: needs-root, isolation-container

Tests: logind
Depends: systemd,
  libpam-systemd,
  acl,
  locales,
  evemu-tools,
Restrictions: needs-root, isolation-machine

Tests: unit-config
Depends: systemd,
  libpam-systemd,
  acl,
  locales,
  evemu-tools,
  python3,
  pkg-config,
Restrictions: needs-root, allow-stderr

Tests: storage
Depends: systemd,
  libpam-systemd,
  acl,
  locales,
  evemu-tools,
  python3,
  pkg-config,
  cryptsetup-bin,
Restrictions: needs-root, isolation-machine

Tests: networkd-test.py
Tests-Directory: test
Depends: systemd,
  libpam-systemd,
  acl,
  locales,
  evemu-tools,
  python3,
  pkg-config,
  cryptsetup-bin,
  systemd-sysv,
  dnsmasq-base
Restrictions: needs-root, isolation-container

Tests: build-login
Depends: systemd,
  libpam-systemd,
  acl,
  locales,
  evemu-tools,
  python3,
  pkg-config,
  cryptsetup-bin,
  systemd-sysv,
  dnsmasq-base,
  build-essential,
  libsystemd-dev,
Restrictions: isolation-container

Tests: boot-and-services
Depends: systemd-sysv,
  systemd-container,
  systemd-coredump,
  libpam-systemd,
  xserver-xorg-video-dummy,
  xserver-xorg,
  lightdm,
  lightdm-gtk-greeter | lightdm-greeter,
  cron,
  network-manager,
  busybox-static,
  apparmor,
  pkg-config,
  python3
Restrictions: needs-root, isolation-machine, needs-recommends, breaks-testbed

Tests: udev
Depends: tree,
  libudev-dev,
  perl,
  xz-utils,
Restrictions: needs-root, allow-stderr, isolation-machine

Tests: upstream
Depends: tree,
  libudev-dev,
  perl,
  xz-utils,
  kbd,
  cryptsetup-bin,
  net-tools,
  isc-dhcp-client,
  iputils-ping,
  strace,
  qemu-system-x86 [amd64],
  less,
  pkg-config,
  gcc,
  libc6-dev | libc-dev,
  make,
  systemd-journal-remote,
  systemd-container,
Restrictions: needs-root, allow-stderr, isolation-machine

Tests: boot-smoke
Depends: systemd-sysv,
  network-manager,
  policykit-1,
  lightdm,
  xserver-xorg-video-dummy,
  tree,
  libudev-dev,
  perl,
  xz-utils,
  kbd,
  cryptsetup-bin,
  net-tools,
  isc-dhcp-client,
  iputils-ping,
  strace,
  qemu-system-x86 [amd64],
  less,
  pkg-config,
  gcc,
  libc6-dev | libc-dev,
  make,
  systemd-journal-remote,
  systemd-container,
Restrictions: needs-recommends, needs-root, isolation-machine, allow-stderr, breaks-testbed

# NOUPSTREAM: Do not run these tests for upstream builds

Tests: systemd-fsckd
Depends: systemd-sysv,
  python3,
  plymouth
Restrictions: needs-root, isolation-machine, needs-recommends, breaks-testbed

=== watch ===
version=3
opts="uversionmangle=s/tp/~alpha1~tp/;s/alpha/~alpha/;s/beta/~beta/;s/rc/~rc/,dversionmangle=s/\+dfsg\d*$//,pgpsigurlmangle=s/tar\.gz/tar.asc/,decompress" \
	  https://download.samba.org/pub/samba samba-(4\.4\..*).tar.gz
